'use strict';

var _Auth = require('../../data/account/Auth');

var _Routing = require('../Routing');

var _Config = require('./Config');

var _Config2 = _interopRequireDefault(_Config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

describe('Call route optimization endpoints', function () {
  it('should response true value', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var result, token, payload, response, expected;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
            result = (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);
            _context.next = 4;
            return result;

          case 4:
            token = _context.sent;
            payload = {
              date: '2018-02-28',
              routeSettingId: 28,
              routingScope: 'all'
            };
            _context.prev = 6;
            _context.next = 9;
            return (0, _Routing.optimizeRouteAsync)(payload, token.accessToken);

          case 9:
            response = _context.sent;
            _context.next = 12;
            return expect('data' in response).toBeTruthy();

          case 12:
            _context.next = 18;
            break;

          case 14:
            _context.prev = 14;
            _context.t0 = _context['catch'](6);
            expected = {
              statusCode: 400,
              statusText: 'Bad Request',
              message: 'Bad Request',
              errorMessage: [{
                key: 'routeSettingId',
                messages: ['Route Setting does not belong to you']
              }]
            };

            expect(_context.t0).toEqual(expected);

          case 18:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[6, 14]]);
  })));
});