'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.refreshTokenAsync = exports.getTokenAsync = undefined;

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _Endpoint = require('../Endpoint');

var _Endpoint2 = _interopRequireDefault(_Endpoint);

var _camelize = require('camelize');

var _camelize2 = _interopRequireDefault(_camelize);

var _Util = require('../utility/Util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * @fileoverview This file contains all authentication related functions that are triggered by a User
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */

/**
 * Get Token
 * @param {string} email
 * @param {string} password
 * @param {string} clientId
 * @param {string} secret
 * @return {object} Promise resolve/reject
 */
var getTokenAsync = exports.getTokenAsync = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(email, password, clientId, secret) {
    var response;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return (0, _axios2.default)({
              method: 'POST',
              url: _Endpoint2.default.OAUTH,
              headers: { 'Content-Type': 'application/json' },
              data: {
                username: email,
                password: password,
                grantType: 'password',
                clientId: clientId,
                clientSecret: secret,
                scope: 'full-access'
              }
            });

          case 3:
            response = _context.sent;
            return _context.abrupt('return', (0, _camelize2.default)(response.data.data));

          case 7:
            _context.prev = 7;
            _context.t0 = _context['catch'](0);
            return _context.abrupt('return', (0, _Util.apiResponseErrorHandler)(_context.t0));

          case 10:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[0, 7]]);
  }));

  return function getTokenAsync(_x, _x2, _x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();

/**
 * Refresh token
 * @param {string} refreshToken
 * @param {string} clientId
 * @param {string} secret
 * @return {object} Promise resolve/reject
 */
var refreshTokenAsync = exports.refreshTokenAsync = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(refreshToken, clientId, secret) {
    var response;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            _context2.next = 3;
            return (0, _axios2.default)({
              method: 'POST',
              url: _Endpoint2.default.OAUTH,
              headers: { 'Content-Type': 'application/json' },
              data: {
                refreshToken: refreshToken,
                grantType: 'refresh_token',
                clientId: clientId,
                clientSecret: secret,
                scope: 'full-access'
              }
            });

          case 3:
            response = _context2.sent;
            return _context2.abrupt('return', (0, _camelize2.default)(response.data.data));

          case 7:
            _context2.prev = 7;
            _context2.t0 = _context2['catch'](0);
            return _context2.abrupt('return', (0, _Util.apiResponseErrorHandler)(_context2.t0));

          case 10:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined, [[0, 7]]);
  }));

  return function refreshTokenAsync(_x5, _x6, _x7) {
    return _ref2.apply(this, arguments);
  };
}();