'use strict';

var _Auth = require('../Auth');

var _Config = require('./Config');

var _Config2 = _interopRequireDefault(_Config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

describe('Auth integration test', function () {
  it('verifies a successful accessToken in the return object', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var response;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 20000;

            _context.next = 3;
            return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

          case 3:
            response = _context.sent;

            expect(response).toHaveProperty('accessToken');

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  })));

  it('test for account alpha.test@carpal.me with wrong password', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var response, expected;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 20000;

            _context2.prev = 1;
            _context2.next = 4;
            return (0, _Auth.getTokenAsync)(_Config2.default.email, 'wrong-password', _Config2.default.clientId, _Config2.default.clientSecret);

          case 4:
            response = _context2.sent;

            expect(response).toBeNull(); // Should not trigger, only if is there is no exception which is not expected behavior
            _context2.next = 12;
            break;

          case 8:
            _context2.prev = 8;
            _context2.t0 = _context2['catch'](1);
            expected = {
              errorMessage: [{
                key: null,
                messages: ['No Account Found or Incorrect Credentials']
              }],
              statusCode: 401,
              statusText: 'Unauthorized'
            };

            expect(_context2.t0).toEqual(expected);

          case 12:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined, [[1, 8]]);
  })));
});