'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getOrderAnalyticsChart = exports.getOrderAnalyticsMetrics = undefined;

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _Endpoint = require('../Endpoint');

var _Endpoint2 = _interopRequireDefault(_Endpoint);

var _camelize = require('camelize');

var _camelize2 = _interopRequireDefault(_camelize);

var _Util = require('../utility/Util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

/**
 * Retrieve Order Analytic Metrics
 * @param {object} params
 * @param {string} token
 * @return {object} Promise resolve/reject
 */
var getOrderAnalyticsMetrics = exports.getOrderAnalyticsMetrics = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(params, token) {
    var response;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return (0, _axios2.default)({
              method: 'GET',
              url: _Endpoint2.default.API_V3.ORDER_ANALYTICS_METRIC,
              headers: { Authorization: 'Bearer ' + token },
              params: params
            });

          case 3:
            response = _context.sent;
            return _context.abrupt('return', (0, _camelize2.default)(response.data.data));

          case 7:
            _context.prev = 7;
            _context.t0 = _context['catch'](0);
            return _context.abrupt('return', (0, _Util.apiResponseErrorHandler)(_context.t0));

          case 10:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[0, 7]]);
  }));

  return function getOrderAnalyticsMetrics(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

/**
 * Retrieve Order Analytic Chart
 * @param {object} params
 * @param {string} token
 * @return {object} Promise resolve/reject
 */
var getOrderAnalyticsChart = exports.getOrderAnalyticsChart = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(params, token) {
    var response;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            _context2.next = 3;
            return (0, _axios2.default)({
              method: 'GET',
              url: _Endpoint2.default.API_V3.ORDER_ANALYTICS_CHART,
              headers: { Authorization: 'Bearer ' + token },
              params: params
            });

          case 3:
            response = _context2.sent;
            return _context2.abrupt('return', (0, _camelize2.default)(response.data.data));

          case 7:
            _context2.prev = 7;
            _context2.t0 = _context2['catch'](0);
            return _context2.abrupt('return', (0, _Util.apiResponseErrorHandler)(_context2.t0));

          case 10:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined, [[0, 7]]);
  }));

  return function getOrderAnalyticsChart(_x3, _x4) {
    return _ref2.apply(this, arguments);
  };
}();