'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _Config = require('./Config');

var _Config2 = _interopRequireDefault(_Config);

var _Auth = require('../../account/Auth');

var _Driver = require('../Driver');

var _momentTimezone = require('moment-timezone');

var _momentTimezone2 = _interopRequireDefault(_momentTimezone);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

describe('Create new driver ', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee21() {
  var token, driver, filterObject, customerId, filterObject2, filterObject3;
  return regeneratorRuntime.wrap(function _callee21$(_context21) {
    while (1) {
      switch (_context21.prev = _context21.next) {
        case 0:
          token = void 0;
          driver = void 0;


          beforeAll(_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context.next = 3;
                    return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

                  case 3:
                    token = _context.sent;

                  case 4:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, undefined);
          })));

          it('should return success driver response and update driver', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
            var driverInfoUpdate, newDriver, response, data;
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    driverInfoUpdate = {
                      transactionGroupIds: [185],
                      sendConfirmationSms: false,
                      sendConfirmationEmail: false,
                      driverTypeIds: [2, 3],
                      firstName: 'User',
                      lastName: generateDisplayName(10),
                      email: generateDisplayName(10) + '@example.com',
                      password: '123456',
                      birthday: '1980-01-01',
                      phone: '+6592' + Math.floor(Math.random() * 1000000),
                      vehicleColor: 'Red',
                      averageSpeed: 60,
                      maximumCapacity: 100,
                      vehicleModelYear: 2018,
                      vehicleLicenseNumber: '12456',
                      vehicleBrand: 'Scooter',
                      vehicleModel: '12456',
                      vehicleTypeId: 1,
                      schedules: [{
                        transactionGroupId: 185,
                        startAt: new Date().toJSON().split('T')[0],
                        isDefault: true,
                        windows: [{
                          startTime: '09:00',
                          endTime: '22:00'
                        }],
                        recursions: [1]
                      }],
                      serviceProviderDriverServiceIds: []
                    };
                    _context2.next = 4;
                    return (0, _Driver.createDriverAsync)(driverInfoUpdate, token.accessToken);

                  case 4:
                    newDriver = _context2.sent;


                    driver = _extends({}, newDriver, {
                      driverStatusId: 2,
                      transactionGroupIds: driverInfoUpdate.transactionGroupIds,
                      driverTypeIds: driverInfoUpdate.driverTypeIds,
                      languageIds: [1] // not sure about this parameter
                    });

                    _context2.next = 8;
                    return (0, _Driver.updateDriverAsync)(driver, {}, token.accessToken);

                  case 8:
                    response = _context2.sent;

                    expect('data' in response).toBeTruthy();
                    data = response.data;

                    expect('id' in data).toBeTruthy();
                    expect('driverDetailsId' in data).toBeTruthy();
                    expect('userId' in data).toBeTruthy();
                    expect('driverStatusId' in data).toBeTruthy();
                    expect('driverStatusName' in data).toBeTruthy();
                    expect('avatar' in data).toBeTruthy();
                    expect('online' in data).toBeTruthy();
                    expect('locationTracking' in data).toBeTruthy();
                    expect('activatedAt' in data).toBeTruthy();
                    expect('lastDeactivatedAt' in data).toBeTruthy();
                    expect('createdAt' in data).toBeTruthy();
                    expect('updatedAt' in data).toBeTruthy();
                    expect('user' in data).toBeTruthy();
                    expect('vehicle' in data).toBeTruthy();

                  case 25:
                  case 'end':
                    return _context2.stop();
                }
              }
            }, _callee2, undefined);
          })));

          it('Update driver should return validation error statusCode 400', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    _context3.prev = 0;

                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context3.next = 4;
                    return (0, _Driver.updateDriverAsync)({}, {}, token.accessToken);

                  case 4:
                    _context3.next = 9;
                    break;

                  case 6:
                    _context3.prev = 6;
                    _context3.t0 = _context3['catch'](0);

                    expect(_context3.t0).toHaveProperty('statusCode', 404);

                  case 9:
                  case 'end':
                    return _context3.stop();
                }
              }
            }, _callee3, undefined, [[0, 6]]);
          })));

          it('should respond new driver object including id details and perform a show request on that driver', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
            var driverInfo, response;
            return regeneratorRuntime.wrap(function _callee4$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    driverInfo = {
                      transactionGroupIds: [185],
                      sendConfirmationSms: false,
                      sendConfirmationEmail: false,
                      driverTypeIds: [2, 3],
                      firstName: 'User',
                      lastName: generateDisplayName(10),
                      email: generateDisplayName(10) + '@example.com',
                      password: '123456',
                      birthday: '1980-01-01',
                      phone: '+6592' + Math.floor(Math.random() * 1000000),
                      vehicleColor: 'Red',
                      averageSpeed: 60,
                      maximumCapacity: 100,
                      vehicleModelYear: 2018,
                      vehicleLicenseNumber: '12456',
                      vehicleBrand: 'Scooter',
                      vehicleModel: '12456',
                      vehicleTypeId: 1,
                      identificationNumber: '1',
                      serviceProviderDriverServiceIds: []
                    };
                    _context4.next = 3;
                    return (0, _Driver.createDriverAsync)(driverInfo, token.accessToken);

                  case 3:
                    response = _context4.sent;

                    expect('id' in response).toBeTruthy();
                    expect('vehicle' in response).toBeTruthy();
                    expect('driverTypes' in response).toBeTruthy();

                  case 7:
                  case 'end':
                    return _context4.stop();
                }
              }
            }, _callee4, undefined);
          })));

          it('Test for retrieving V3 driver list', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
            var filters, response;
            return regeneratorRuntime.wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    filters = {
                      limit: 2,
                      page: 1
                    };
                    _context5.next = 4;
                    return (0, _Driver.getDriversAsync)(filters, token.accessToken);

                  case 4:
                    response = _context5.sent;

                    expect('data' in response).toBeTruthy();
                    expect(response.data instanceof Array).toBeTruthy();

                  case 7:
                  case 'end':
                    return _context5.stop();
                }
              }
            }, _callee5, undefined);
          })));

          describe('Test for create, update and delete driver schedule', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11() {
            var schedule;
            return regeneratorRuntime.wrap(function _callee11$(_context11) {
              while (1) {
                switch (_context11.prev = _context11.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 90000;
                    schedule = void 0;
                    // const originalDriverDatum = {
                    //   activeStatusCounts: { '1': 0, '2': 0, '3': 0, '4': 0 },
                    //   driverTypeCounts: { '1': 1, '2': 3, '3': 4 },
                    //   data: {
                    //     '1': [],
                    //     '2': [],
                    //     '3': [
                    //       {
                    //         addressId: 0,
                    //         driverId: 9168,
                    //         customerId: 10919,
                    //         orderId: 62411,
                    //         driverStatusId: 3,
                    //         driverTypeIds: [1],
                    //         id: '9b4cf220-cd94-4a0b-84ac-32f74dfc142f',
                    //         latitude: '1.2788882',
                    //         longitude: '103.8482516',
                    //         orderRouteTypeId: 1,
                    //         updatedAt: '2018-01-11 06:06:57',
                    //       },
                    //     ],
                    //     '4': [],
                    //   },
                    //   totalStatusCounts: 0,
                    // };
                    // const pubSubPayload = {
                    //   data: {
                    //     addressId: 0,
                    //     customerId: 10919,
                    //     driverId: 9168,
                    //     driverTypeIds: [1],
                    //     id: '1ada3ace-67ab-4e3b-a1e0-a0d3b63fedc8',
                    //     latitude: '1.2789042',
                    //     longitude: '103.8482397',
                    //     orderId: 62411,
                    //     orderRouteTypeId: 1,
                    //     updatedAt: '2018-01-11 06:06:14',
                    //     // "driverStatusId": 4
                    //   },
                    //   lastDriverStatusId: 1,
                    // };

                    // const filterObject = {
                    //   // driverStatusIds: [2],
                    //   orderRouteTypeIds: 1,
                    //   driverTypeIds: [1],
                    // };

                    it('Test for creating the driver schedule', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
                      var payload;
                      return regeneratorRuntime.wrap(function _callee6$(_context6) {
                        while (1) {
                          switch (_context6.prev = _context6.next) {
                            case 0:
                              payload = {
                                driverId: driver.id,
                                transactionGroupId: 185,
                                windows: [{
                                  startTime: '10:01',
                                  endTime: '13:02'
                                }],
                                startAt: '2020-03-05'
                              };
                              _context6.next = 3;
                              return (0, _Driver.createDriverScheduleAsync)(payload, {}, token.accessToken);

                            case 3:
                              schedule = _context6.sent;


                              expect('data' in schedule).toBeTruthy();

                            case 5:
                            case 'end':
                              return _context6.stop();
                          }
                        }
                      }, _callee6, undefined);
                    })));

                    it('Test for updating the driver schedule', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
                      var payload, responseUpdateSchedule;
                      return regeneratorRuntime.wrap(function _callee7$(_context7) {
                        while (1) {
                          switch (_context7.prev = _context7.next) {
                            case 0:
                              payload = {
                                driverId: driver.id,
                                transactionGroupId: 185,
                                windows: [{
                                  startTime: '10:01',
                                  endTime: '13:02'
                                }],
                                startAt: '2020-03-05'
                              };
                              _context7.next = 3;
                              return (0, _Driver.updateDriverScheduleAsync)(schedule.data.id, payload, token.accessToken);

                            case 3:
                              responseUpdateSchedule = _context7.sent;


                              expect('data' in responseUpdateSchedule).toBeTruthy();

                            case 5:
                            case 'end':
                              return _context7.stop();
                          }
                        }
                      }, _callee7, undefined);
                    })));

                    it('Test for deleting the driver schedule', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
                      return regeneratorRuntime.wrap(function _callee9$(_context9) {
                        while (1) {
                          switch (_context9.prev = _context9.next) {
                            case 0:
                              setTimeout(_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
                                var responseDelete;
                                return regeneratorRuntime.wrap(function _callee8$(_context8) {
                                  while (1) {
                                    switch (_context8.prev = _context8.next) {
                                      case 0:
                                        _context8.next = 2;
                                        return (0, _Driver.deleteDriverScheduleAsync)(schedule.data.id, token.accessToken);

                                      case 2:
                                        responseDelete = _context8.sent;

                                        expect('data' in responseDelete).toBeTruthy();

                                      case 4:
                                      case 'end':
                                        return _context8.stop();
                                    }
                                  }
                                }, _callee8, undefined);
                              })), 1000);

                            case 1:
                            case 'end':
                              return _context9.stop();
                          }
                        }
                      }, _callee9, undefined);
                    })));

                    it('should fail for deleting the driver schedule with wrong id', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10() {
                      var expected;
                      return regeneratorRuntime.wrap(function _callee10$(_context10) {
                        while (1) {
                          switch (_context10.prev = _context10.next) {
                            case 0:
                              _context10.prev = 0;
                              _context10.next = 3;
                              return (0, _Driver.deleteDriverScheduleAsync)(1234, token.accessToken);

                            case 3:
                              _context10.next = 9;
                              break;

                            case 5:
                              _context10.prev = 5;
                              _context10.t0 = _context10['catch'](0);
                              expected = {
                                statusCode: 404,
                                statusText: 'Not Found',
                                message: 'Not Found',
                                errorMessage: [{ key: 'driverSchedule', messages: ['Driver Schedule not found'] }]
                              };

                              expect(_context10.t0).toEqual(expected);

                            case 9:
                            case 'end':
                              return _context10.stop();
                          }
                        }
                      }, _callee10, undefined, [[0, 5]]);
                    })));

                  case 6:
                  case 'end':
                    return _context11.stop();
                }
              }
            }, _callee11, undefined);
          })));

          it('Test for create driver schedule with with driver that does not belong to requestor', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12() {
            var payload, response;
            return regeneratorRuntime.wrap(function _callee12$(_context12) {
              while (1) {
                switch (_context12.prev = _context12.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    payload = {
                      driverId: 99999999999912,
                      transactionGroupId: 185,
                      windows: [{
                        startTime: '09:00',
                        endTime: '22:00'
                      }],
                      startAt: (0, _momentTimezone2.default)().format('YYYY-MM-DD')
                    };
                    _context12.prev = 2;
                    _context12.next = 5;
                    return (0, _Driver.createDriverScheduleAsync)(payload, {}, token.accessToken);

                  case 5:
                    response = _context12.sent;

                    expect('data' in response).toBeTruthy();
                    _context12.next = 13;
                    break;

                  case 9:
                    _context12.prev = 9;
                    _context12.t0 = _context12['catch'](2);

                    expect(_context12.t0).toHaveProperty('statusCode', 400);
                    expect(_context12.t0).toHaveProperty('errorMessage', [{
                      key: 'driverId',
                      messages: ['Driver does not belong to you', 'Driver does not match Transaction Group']
                    }]);

                  case 13:
                  case 'end':
                    return _context12.stop();
                }
              }
            }, _callee12, undefined, [[2, 9]]);
          })));

          filterObject = {
            driverStatusIds: [2],
            orderRouteTypeIds: 1,
            driverTypeIds: [1]
          };
          customerId = 14445;


          it('should get getDriversWithFiltersAsync success response', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13() {
            var response;
            return regeneratorRuntime.wrap(function _callee13$(_context13) {
              while (1) {
                switch (_context13.prev = _context13.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context13.prev = 1;
                    _context13.next = 4;
                    return (0, _Driver.getDriversWithFiltersAsync)(filterObject, customerId, token.accessToken);

                  case 4:
                    response = _context13.sent;

                    expect(response).toMatchSnapshot();
                    _context13.next = 10;
                    break;

                  case 8:
                    _context13.prev = 8;
                    _context13.t0 = _context13['catch'](1);

                  case 10:
                  case 'end':
                    return _context13.stop();
                }
              }
            }, _callee13, undefined, [[1, 8]]);
          }))
          //
          );
          it('should throw getDriversWithFiltersAsync 401 error status', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee14() {
            return regeneratorRuntime.wrap(function _callee14$(_context14) {
              while (1) {
                switch (_context14.prev = _context14.next) {
                  case 0:
                    _context14.prev = 0;
                    _context14.next = 3;
                    return (0, _Driver.getDriverCountsAsync)();

                  case 3:
                    _context14.next = 8;
                    break;

                  case 5:
                    _context14.prev = 5;
                    _context14.t0 = _context14['catch'](0);

                    expect(_context14.t0).toHaveProperty('statusCode', 401);

                  case 8:
                  case 'end':
                    return _context14.stop();
                }
              }
            }, _callee14, undefined, [[0, 5]]);
          })));

          filterObject2 = {
            driverStatusIds: [2],
            orderRouteTypeIds: 1,
            driverTypeIds: [1]
          };

          it('should get getDriverCountsAsync success response', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee15() {
            var response;
            return regeneratorRuntime.wrap(function _callee15$(_context15) {
              while (1) {
                switch (_context15.prev = _context15.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context15.prev = 1;
                    _context15.next = 4;
                    return (0, _Driver.getDriverCountsAsync)(filterObject2, customerId, token.accessToken);

                  case 4:
                    response = _context15.sent;

                    expect(response).toMatchSnapshot();
                    _context15.next = 10;
                    break;

                  case 8:
                    _context15.prev = 8;
                    _context15.t0 = _context15['catch'](1);

                  case 10:
                  case 'end':
                    return _context15.stop();
                }
              }
            }, _callee15, undefined, [[1, 8]]);
          }))
          //
          );
          it('should throw getDriverCountsAsync 401 error status', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee16() {
            return regeneratorRuntime.wrap(function _callee16$(_context16) {
              while (1) {
                switch (_context16.prev = _context16.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context16.prev = 1;
                    _context16.next = 4;
                    return (0, _Driver.getDriverCountsAsync)();

                  case 4:
                    _context16.next = 9;
                    break;

                  case 6:
                    _context16.prev = 6;
                    _context16.t0 = _context16['catch'](1);

                    expect(_context16.t0).toHaveProperty('statusCode', 401);

                  case 9:
                  case 'end':
                    return _context16.stop();
                }
              }
            }, _callee16, undefined, [[1, 6]]);
          })));
          filterObject3 = {
            pickupDate: '2018-02-28',
            withRoute: 0,
            sort: 'pickup_window,asc',
            limit: 1,
            offset: 1,
            include: 'pickup_group,delivery_address',
            statusIds: 2, // 2 is for validated records
            recommendedForDriverId: 20
          };

          it('should get getDriverRoutesAsync success response', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee17() {
            var response, dataObj;
            return regeneratorRuntime.wrap(function _callee17$(_context17) {
              while (1) {
                switch (_context17.prev = _context17.next) {
                  case 0:
                    _context17.prev = 0;
                    _context17.next = 3;
                    return (0, _Driver.getDriverRoutesAsync)(filterObject3, token.accessToken);

                  case 3:
                    response = _context17.sent;

                    expect(_typeof(response.data)).toBe('object');
                    dataObj = response.data['' + Object.keys(response.data)[0]];

                    expect(dataObj).toHaveProperty('id');
                    expect(dataObj).toHaveProperty('driverDetailsId');
                    expect(dataObj).toHaveProperty('userId');
                    expect(dataObj).toHaveProperty('driverStatusId');
                    expect(dataObj).toHaveProperty('driverStatusName');
                    expect(dataObj).toHaveProperty('avatar');
                    expect(dataObj).toHaveProperty('activatedAt');
                    expect(dataObj).toHaveProperty('createdAt');
                    expect(dataObj).toHaveProperty('updatedAt');
                    expect(dataObj).toHaveProperty('user');
                    expect(dataObj).toHaveProperty('vehicle');
                    expect(dataObj).toHaveProperty('driverTypes');
                    expect(dataObj).toHaveProperty('driverGeofences');
                    expect(dataObj).toHaveProperty('driverSchedules');
                    expect(dataObj).toHaveProperty('driverAssignments');
                    expect(dataObj).toHaveProperty('routes');
                    _context17.next = 26;
                    break;

                  case 24:
                    _context17.prev = 24;
                    _context17.t0 = _context17['catch'](0);

                  case 26:
                  case 'end':
                    return _context17.stop();
                }
              }
            }, _callee17, undefined, [[0, 24]]);
          }))
          //
          );

          it('should throw getDriverRoutesAsync 401 error status', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee18() {
            return regeneratorRuntime.wrap(function _callee18$(_context18) {
              while (1) {
                switch (_context18.prev = _context18.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context18.prev = 1;
                    _context18.next = 4;
                    return (0, _Driver.getDriverCountsAsync)();

                  case 4:
                    _context18.next = 9;
                    break;

                  case 6:
                    _context18.prev = 6;
                    _context18.t0 = _context18['catch'](1);

                    expect(_context18.t0).toHaveProperty('statusCode', 401);

                  case 9:
                  case 'end':
                    return _context18.stop();
                }
              }
            }, _callee18, undefined, [[1, 6]]);
          })));

          /*  it('should delete drivers', async () => {
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 30000;
            const driverInfo = {
              transactionGroupIds: [185],
              sendConfirmationSms: false,
              sendConfirmationEmail: false,
              driverTypeIds: [2],
              firstName: 'User',
              lastName: generateDisplayName(10),
              email: `${generateDisplayName(10)}@example.com`,
              password: '123456',
              birthday: '1980-01-01',
              phone: `+6596381695`,
              vehicleColor: 'Red',
              averageSpeed: 60,
              maximumCapacity: 100,
              vehicleModelYear: 2018,
              vehicleLicenseNumber: '12456',
              vehicleBrand: 'Scooter',
              vehicleModel: '12456',
              vehicleTypeId: 1,
            };
            try {
              const response = await createDriverAsync(driverInfo, token.accessToken);
              const deleted = await deleteDriversAsync(response.id, token.accessToken);
              expect('data' in deleted).toBeTruthy();
            } catch (error) {
              expect(error).toHaveProperty('statusCode', 401);
            }
          });*/

          it('should throw assignToFreelancer 404 error status', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee19() {
            var params;
            return regeneratorRuntime.wrap(function _callee19$(_context19) {
              while (1) {
                switch (_context19.prev = _context19.next) {
                  case 0:
                    _context19.prev = 0;

                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    params = {
                      order_ids: [10001],
                      single_order_per_job: true
                    };
                    _context19.next = 5;
                    return (0, _Driver.assignToFreelancer)(123, params, token.accessToken);

                  case 5:
                    _context19.next = 10;
                    break;

                  case 7:
                    _context19.prev = 7;
                    _context19.t0 = _context19['catch'](0);

                    expect(_context19.t0).toHaveProperty('statusCode', 404);

                  case 10:
                  case 'end':
                    return _context19.stop();
                }
              }
            }, _callee19, undefined, [[0, 7]]);
          })));

          it('should get getSearchedDrivers success response', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee20() {
            var params, response;
            return regeneratorRuntime.wrap(function _callee20$(_context20) {
              while (1) {
                switch (_context20.prev = _context20.next) {
                  case 0:
                    _context20.prev = 0;

                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    params = {
                      keyword: 'test',
                      driver_status_id: 2, // Activated
                      driver_type_id: 1, // Public/Freelance
                      limit: 10,
                      offset: 0
                    };
                    _context20.next = 5;
                    return (0, _Driver.getSearchedDrivers)(params, token.accessToken);

                  case 5:
                    response = _context20.sent;

                    expect(response).toMatchSnapshot();
                    _context20.next = 12;
                    break;

                  case 9:
                    _context20.prev = 9;
                    _context20.t0 = _context20['catch'](0);

                    expect(_context20.t0).toHaveProperty('statusCode', 400);

                  case 12:
                  case 'end':
                    return _context20.stop();
                }
              }
            }, _callee20, undefined, [[0, 9]]);
          })));

        case 21:
        case 'end':
          return _context21.stop();
      }
    }
  }, _callee21, undefined);
})));

/**
 * Generate a display name
 * @param {int} size
 * @return {string} text
 */
function generateDisplayName(size) {
  var text = '';
  var possible = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';

  for (var i = 0; i < size; i++) {
    text += possible.charAt(Math.floor(Math.random() * possible.length));
  }

  return text;
}

describe('Create Driver Payment ', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee27() {
  var token;
  return regeneratorRuntime.wrap(function _callee27$(_context27) {
    while (1) {
      switch (_context27.prev = _context27.next) {
        case 0:
          token = void 0;


          beforeAll(_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee22() {
            return regeneratorRuntime.wrap(function _callee22$(_context22) {
              while (1) {
                switch (_context22.prev = _context22.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context22.next = 3;
                    return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

                  case 3:
                    token = _context22.sent;

                  case 4:
                  case 'end':
                    return _context22.stop();
                }
              }
            }, _callee22, undefined);
          })));

          it('should get driver payments', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee23() {
            var response;
            return regeneratorRuntime.wrap(function _callee23$(_context23) {
              while (1) {
                switch (_context23.prev = _context23.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context23.prev = 1;
                    _context23.next = 4;
                    return (0, _Driver.getDriverPaymentAsync)(token.accessToken);

                  case 4:
                    response = _context23.sent;

                    expect('data' in response).toBeTruthy();
                    expect(response.data instanceof Array).toBeTruthy();
                    _context23.next = 12;
                    break;

                  case 9:
                    _context23.prev = 9;
                    _context23.t0 = _context23['catch'](1);

                    expect(_context23.t0).toHaveProperty('statusCode', 403);

                  case 12:
                  case 'end':
                    return _context23.stop();
                }
              }
            }, _callee23, undefined, [[1, 9]]);
          })));

          it('should create driver payments', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee24() {
            var response;
            return regeneratorRuntime.wrap(function _callee24$(_context24) {
              while (1) {
                switch (_context24.prev = _context24.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context24.prev = 1;
                    _context24.next = 4;
                    return (0, _Driver.createDriverPaymentAsync)(token.accessToken);

                  case 4:
                    response = _context24.sent;

                    expect('data' in response).toBeTruthy();
                    expect(response.data instanceof Array).toBeTruthy();
                    _context24.next = 12;
                    break;

                  case 9:
                    _context24.prev = 9;
                    _context24.t0 = _context24['catch'](1);

                    expect(_context24.t0).toHaveProperty('statusCode', 403);

                  case 12:
                  case 'end':
                    return _context24.stop();
                }
              }
            }, _callee24, undefined, [[1, 9]]);
          })));

          it('should update driver payments', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee25() {
            var response;
            return regeneratorRuntime.wrap(function _callee25$(_context25) {
              while (1) {
                switch (_context25.prev = _context25.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context25.prev = 1;
                    _context25.next = 4;
                    return (0, _Driver.updateDriverPaymentAsync)(1, { status_id: 2 }, token.accessToken);

                  case 4:
                    response = _context25.sent;

                    expect('data' in response).toBeTruthy();
                    expect(response.data instanceof Array).toBeTruthy();
                    _context25.next = 12;
                    break;

                  case 9:
                    _context25.prev = 9;
                    _context25.t0 = _context25['catch'](1);

                    expect(_context25.t0).toHaveProperty('statusCode', 403);

                  case 12:
                  case 'end':
                    return _context25.stop();
                }
              }
            }, _callee25, undefined, [[1, 9]]);
          })));

          it('should download driver payments', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee26() {
            var response;
            return regeneratorRuntime.wrap(function _callee26$(_context26) {
              while (1) {
                switch (_context26.prev = _context26.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context26.prev = 1;
                    _context26.next = 4;
                    return (0, _Driver.downloadDriverPaymentAsync)(1, token.accessToken);

                  case 4:
                    response = _context26.sent;

                    expect('data' in response).toBeTruthy();
                    expect(response.data instanceof Array).toBeTruthy();
                    _context26.next = 12;
                    break;

                  case 9:
                    _context26.prev = 9;
                    _context26.t0 = _context26['catch'](1);

                    expect(_context26.t0).toHaveProperty('statusCode', 403);

                  case 12:
                  case 'end':
                    return _context26.stop();
                }
              }
            }, _callee26, undefined, [[1, 9]]);
          })));

        case 6:
        case 'end':
          return _context27.stop();
      }
    }
  }, _callee27, undefined);
})));