'use strict';

var _Order = require('../Order');

var _Auth = require('../../account/Auth');

var _Util = require('../../utility/Util');

var _Config = require('./Config');

var _Config2 = _interopRequireDefault(_Config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var token = void 0;
beforeAll(_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
          _context.next = 3;
          return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

        case 3:
          token = _context.sent;

        case 4:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, undefined);
})));

describe('Order tests', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee20() {
  return regeneratorRuntime.wrap(function _callee20$(_context20) {
    while (1) {
      switch (_context20.prev = _context20.next) {
        case 0:
          it('Should get template file for order upload', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
            var response;
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context2.prev = 1;
                    _context2.next = 4;
                    return (0, _Order.getOrderUploadTemplateAsync)(_Config2.default.pickupDate, token.accessToken);

                  case 4:
                    response = _context2.sent;


                    expect(response).toEqual(jasmine.any(Object));
                    _context2.next = 11;
                    break;

                  case 8:
                    _context2.prev = 8;
                    _context2.t0 = _context2['catch'](1);

                    expect(_context2.t0).toHaveProperty('statusCode', 404);

                  case 11:
                  case 'end':
                    return _context2.stop();
                }
              }
            }, _callee2, undefined, [[1, 8]]);
          })));

          it('Retrieving single order, expect 404', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
            var params, response;
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    params = {
                      include: 'route_locations,service_providers.customer.user,quote,service_type,vehicle_service,job_driver.user,driver_fee'
                    };
                    _context3.prev = 2;
                    _context3.next = 5;
                    return (0, _Order.getOrderAsync)(_Config2.default.groupingLocationId, params, token.accessToken);

                  case 5:
                    response = _context3.sent;

                    expect('data' in response).toBeTruthy();
                    _context3.next = 12;
                    break;

                  case 9:
                    _context3.prev = 9;
                    _context3.t0 = _context3['catch'](2);

                    expect(_context3.t0).toHaveProperty('statusCode', 404);

                  case 12:
                  case 'end':
                    return _context3.stop();
                }
              }
            }, _callee3, undefined, [[2, 9]]);
          })));

          it('Retrieving validated orders', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
            var filterObject, response;
            return regeneratorRuntime.wrap(function _callee4$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    filterObject = {
                      statusIds: 2, // 2 = validated records, 4 = errors
                      pickupDate: '2018-02-28',
                      limit: 30,
                      offset: 0
                    };


                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context4.prev = 3;
                    _context4.next = 6;
                    return (0, _Order.getOrdersGroupByPickUpAddressAsync)(filterObject, _Config2.default.customerId, token.accessToken);

                  case 6:
                    response = _context4.sent;

                    expect('data' in response).toBeTruthy();
                    expect('totalLocationCount' in response).toBeTruthy();
                    expect('successLocationCount' in response).toBeTruthy();
                    expect('failedLocationCount' in response).toBeTruthy();
                    _context4.next = 16;
                    break;

                  case 13:
                    _context4.prev = 13;
                    _context4.t0 = _context4['catch'](3);

                    expect(_context4.t0).toHaveProperty('statusCode', 401);

                  case 16:
                  case 'end':
                    return _context4.stop();
                }
              }
            }, _callee4, undefined, [[3, 13]]);
          })));

          it('Retrieving orders empty batch', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
            var filterObject, response;
            return regeneratorRuntime.wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    filterObject = {
                      statusIds: 4,
                      pickupDate: '2010-02-28',
                      limit: 30,
                      offset: 0
                    };
                    _context5.prev = 2;
                    _context5.next = 5;
                    return (0, _Order.getOrdersGroupByPickUpAddressAsync)(filterObject, _Config2.default.customerId, token.accessToken);

                  case 5:
                    response = _context5.sent;


                    expect('data' in response).toBeTruthy();
                    expect('totalLocationCount' in response).toBeTruthy();
                    expect('successLocationCount' in response).toBeTruthy();
                    expect('failedLocationCount' in response).toBeTruthy();
                    expect(response).toHaveProperty('totalLocationCount', 0);
                    _context5.next = 16;
                    break;

                  case 13:
                    _context5.prev = 13;
                    _context5.t0 = _context5['catch'](2);

                    expect(_context5.t0).toHaveProperty('statusCode', 400);

                  case 16:
                  case 'end':
                    return _context5.stop();
                }
              }
            }, _callee5, undefined, [[2, 13]]);
          })));

          it('Retrieving Remaining Order Count', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
            var filterObject, responseCount;
            return regeneratorRuntime.wrap(function _callee6$(_context6) {
              while (1) {
                switch (_context6.prev = _context6.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    filterObject = {
                      pickupDate: '2018-04-15',
                      withJob: 0
                    };
                    _context6.prev = 2;
                    _context6.next = 5;
                    return (0, _Order.getRemainingOrdersCountAsync)(filterObject, token.accessToken);

                  case 5:
                    responseCount = _context6.sent;

                    expect('totalCount' in responseCount).toBeTruthy();
                    _context6.next = 12;
                    break;

                  case 9:
                    _context6.prev = 9;
                    _context6.t0 = _context6['catch'](2);

                    expect(_context6.t0).toHaveProperty('statusCode', 401);

                  case 12:
                  case 'end':
                    return _context6.stop();
                }
              }
            }, _callee6, undefined, [[2, 9]]);
          })));

          it('Retrieving error orders from DynamoDB', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
            var response;
            return regeneratorRuntime.wrap(function _callee7$(_context7) {
              while (1) {
                switch (_context7.prev = _context7.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context7.prev = 1;
                    _context7.next = 4;
                    return (0, _Order.getErrorOrderContentsAsync)({
                      pickupDateStart: _Config2.default.pickupDate,
                      pickupDateEnd: _Config2.default.pickupDate
                    }, token.accessToken);

                  case 4:
                    response = _context7.sent;

                    expect(response.data instanceof Array).toBeTruthy();
                    _context7.next = 11;
                    break;

                  case 8:
                    _context7.prev = 8;
                    _context7.t0 = _context7['catch'](1);

                    expect(_context7.t0).toHaveProperty('statusCode', 401);

                  case 11:
                  case 'end':
                    return _context7.stop();
                }
              }
            }, _callee7, undefined, [[1, 8]]);
          })));

          it('Retrieving pickup group', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
            var pickupGroupFilters, response;
            return regeneratorRuntime.wrap(function _callee8$(_context8) {
              while (1) {
                switch (_context8.prev = _context8.next) {
                  case 0:
                    pickupGroupFilters = {
                      pickupDate: '2018-02-05',
                      withOrder: 0
                    };

                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context8.prev = 2;
                    _context8.next = 5;
                    return (0, _Order.getUniquePickupAddressesAsync)(pickupGroupFilters, token.accessToken);

                  case 5:
                    response = _context8.sent;

                    expect('data' in response).toBeTruthy();
                    expect(response.data instanceof Array).toBeTruthy();
                    _context8.next = 13;
                    break;

                  case 10:
                    _context8.prev = 10;
                    _context8.t0 = _context8['catch'](2);

                    expect(_context8.t0).toHaveProperty('statusCode', 401);

                  case 13:
                  case 'end':
                    return _context8.stop();
                }
              }
            }, _callee8, undefined, [[2, 10]]);
          })));

          it('Create Order with date in the past', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
            var response, expected;
            return regeneratorRuntime.wrap(function _callee9$(_context9) {
              while (1) {
                switch (_context9.prev = _context9.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context9.prev = 1;
                    _context9.next = 4;
                    return (0, _Order.createOrderAsync)(_Config2.default.locationObject, token.accessToken);

                  case 4:
                    response = _context9.sent;

                    expect('data' in response).toBeTruthy();
                    _context9.next = 12;
                    break;

                  case 8:
                    _context9.prev = 8;
                    _context9.t0 = _context9['catch'](1);
                    expected = {
                      errorMessage: [{
                        key: 'orderData',
                        messages: {
                          pickupDate: ['The pickup date should be after or equal current date.']
                        }
                      }],
                      statusCode: 400,
                      statusText: 'Bad Request',
                      message: 'Bad Request'
                    };

                    expect(_context9.t0).toEqual(expected);

                  case 12:
                  case 'end':
                    return _context9.stop();
                }
              }
            }, _callee9, undefined, [[1, 8]]);
          })));

          it('Create Service Provider Order ', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10() {
            var response;
            return regeneratorRuntime.wrap(function _callee10$(_context10) {
              while (1) {
                switch (_context10.prev = _context10.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 30000;

                    _context10.prev = 1;
                    _context10.next = 4;
                    return (0, _Order.createServiceProviderOrderAsync)(_Config2.default.locationObjectFutureDate, token.accessToken);

                  case 4:
                    response = _context10.sent;

                    expect('data' in response).toBeTruthy();
                    _context10.next = 11;
                    break;

                  case 8:
                    _context10.prev = 8;
                    _context10.t0 = _context10['catch'](1);

                    expect(_context10.t0).toHaveProperty('statusCode', 403);

                  case 11:
                  case 'end':
                    return _context10.stop();
                }
              }
            }, _callee10, undefined, [[1, 8]]);
          })));

          it('Create Order with date in the future', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11() {
            var response;
            return regeneratorRuntime.wrap(function _callee11$(_context11) {
              while (1) {
                switch (_context11.prev = _context11.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 30000;

                    _context11.prev = 1;
                    _context11.next = 4;
                    return (0, _Order.createOrderAsync)(_Config2.default.locationObjectFutureDate, token.accessToken);

                  case 4:
                    response = _context11.sent;

                    expect('data' in response).toBeTruthy();
                    _context11.next = 11;
                    break;

                  case 8:
                    _context11.prev = 8;
                    _context11.t0 = _context11['catch'](1);

                    expect(_context11.t0).toHaveProperty('statusCode', 400);

                  case 11:
                  case 'end':
                    return _context11.stop();
                }
              }
            }, _callee11, undefined, [[1, 8]]);
          })));

          it('Edit Order not found', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12() {
            var response, expected;
            return regeneratorRuntime.wrap(function _callee12$(_context12) {
              while (1) {
                switch (_context12.prev = _context12.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context12.prev = 1;
                    _context12.next = 4;
                    return (0, _Order.editOrderAsync)(1, { pickupDate: '28-02-2018' }, token.accessToken);

                  case 4:
                    response = _context12.sent;


                    expect('data' in response).toBeTruthy();
                    _context12.next = 12;
                    break;

                  case 8:
                    _context12.prev = 8;
                    _context12.t0 = _context12['catch'](1);
                    expected = {
                      errorMessage: [{ key: 'orderId', messages: ['Order not found'] }],
                      statusCode: 404,
                      statusText: 'Not Found',
                      message: 'Not Found'
                    };

                    expect(_context12.t0).toEqual(expected);

                  case 12:
                  case 'end':
                    return _context12.stop();
                }
              }
            }, _callee12, undefined, [[1, 8]]);
          })));

          it('Edit Order Sync not found', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13() {
            var response, expected;
            return regeneratorRuntime.wrap(function _callee13$(_context13) {
              while (1) {
                switch (_context13.prev = _context13.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context13.prev = 1;
                    _context13.next = 4;
                    return (0, _Order.editOrderSync)(1, { pickupDate: '28-02-2018' }, {}, token.accessToken);

                  case 4:
                    response = _context13.sent;


                    expect('data' in response).toBeTruthy();
                    _context13.next = 12;
                    break;

                  case 8:
                    _context13.prev = 8;
                    _context13.t0 = _context13['catch'](1);
                    expected = {
                      errorMessage: [{ key: 'orderId', messages: ['Order not found'] }],
                      statusCode: 404,
                      statusText: 'Not Found',
                      message: 'Not Found'
                    };

                    expect(_context13.t0).toEqual(expected);

                  case 12:
                  case 'end':
                    return _context13.stop();
                }
              }
            }, _callee13, undefined, [[1, 8]]);
          })));

          it('Test for uploading batch order progression', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee14() {
            var response;
            return regeneratorRuntime.wrap(function _callee14$(_context14) {
              while (1) {
                switch (_context14.prev = _context14.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context14.prev = 1;
                    _context14.next = 4;
                    return (0, _Order.getUploadedOrderProgressionAsync)(1, token.accessToken);

                  case 4:
                    response = _context14.sent;

                    expect('data' in response).toBeTruthy();
                    _context14.next = 11;
                    break;

                  case 8:
                    _context14.prev = 8;
                    _context14.t0 = _context14['catch'](1);

                    expect(_context14.t0).toHaveProperty('statusCode', 401);

                  case 11:
                  case 'end':
                    return _context14.stop();
                }
              }
            }, _callee14, undefined, [[1, 8]]);
          })));

          it('Delete Grouping Location not found', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee15() {
            var response, expected;
            return regeneratorRuntime.wrap(function _callee15$(_context15) {
              while (1) {
                switch (_context15.prev = _context15.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context15.prev = 1;
                    _context15.next = 4;
                    return (0, _Order.deleteOrderAsync)(1, token.accessToken);

                  case 4:
                    response = _context15.sent;

                    expect(response.data).toBeTruthy();
                    _context15.next = 12;
                    break;

                  case 8:
                    _context15.prev = 8;
                    _context15.t0 = _context15['catch'](1);
                    expected = {
                      statusCode: 404,
                      statusText: 'Not Found',
                      message: 'Not Found',
                      errorMessage: [{ key: 'orderId', messages: ['Order not found'] }]
                    };

                    expect(_context15.t0).toEqual(expected);

                  case 12:
                  case 'end':
                    return _context15.stop();
                }
              }
            }, _callee15, undefined, [[1, 8]]);
          })));

          it('Delete Multiple Grouping Locations not found', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee16() {
            var response, expected;
            return regeneratorRuntime.wrap(function _callee16$(_context16) {
              while (1) {
                switch (_context16.prev = _context16.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context16.prev = 1;
                    _context16.next = 4;
                    return (0, _Order.deleteOrdersAsync)(_Config2.default.groupingLocationIds, token.accessToken);

                  case 4:
                    response = _context16.sent;

                    expect(response.data).toBeTruthy();
                    _context16.next = 12;
                    break;

                  case 8:
                    _context16.prev = 8;
                    _context16.t0 = _context16['catch'](1);
                    expected = {
                      statusCode: 404,
                      statusText: 'Not Found',
                      message: 'Not Found',
                      errorMessage: [{ key: 'orderIds', messages: ['Order not found'] }]
                    };

                    expect(_context16.t0).toEqual(expected);

                  case 12:
                  case 'end':
                    return _context16.stop();
                }
              }
            }, _callee16, undefined, [[1, 8]]);
          })));

          it('Update orders to dispatch to 3PL', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee17() {
            return regeneratorRuntime.wrap(function _callee17$(_context17) {
              while (1) {
                switch (_context17.prev = _context17.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context17.prev = 1;
                    _context17.next = 4;
                    return (0, _Order.updateOrderDispatchTo3PL)([], token.accessToken);

                  case 4:
                    _context17.next = 9;
                    break;

                  case 6:
                    _context17.prev = 6;
                    _context17.t0 = _context17['catch'](1);

                    expect(_context17.t0).toHaveProperty('statusCode', 400);

                  case 9:
                  case 'end':
                    return _context17.stop();
                }
              }
            }, _callee17, undefined, [[1, 6]]);
          })));

          it('Broadcast orders to freelancers', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee18() {
            var params, response;
            return regeneratorRuntime.wrap(function _callee18$(_context18) {
              while (1) {
                switch (_context18.prev = _context18.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    params = {
                      order_ids: [10001]
                    };
                    _context18.prev = 2;
                    _context18.next = 5;
                    return (0, _Order.broadcastToFreelancers)(params, token.accessToken);

                  case 5:
                    response = _context18.sent;

                    expect(response).toMatchSnapshot();
                    _context18.next = 12;
                    break;

                  case 9:
                    _context18.prev = 9;
                    _context18.t0 = _context18['catch'](2);

                    expect(_context18.t0).toHaveProperty('statusCode', 400);

                  case 12:
                  case 'end':
                    return _context18.stop();
                }
              }
            }, _callee18, undefined, [[2, 9]]);
          })));

          it('Delete Order dispatch', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee19() {
            var response, expected;
            return regeneratorRuntime.wrap(function _callee19$(_context19) {
              while (1) {
                switch (_context19.prev = _context19.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context19.prev = 1;
                    _context19.next = 4;
                    return (0, _Order.deleteOrderDispatchAsync)(1, token.accessToken);

                  case 4:
                    response = _context19.sent;

                    expect(response.data).toBeTruthy();
                    _context19.next = 12;
                    break;

                  case 8:
                    _context19.prev = 8;
                    _context19.t0 = _context19['catch'](1);
                    expected = {
                      statusCode: 404,
                      statusText: 'Not Found',
                      message: 'Not Found',
                      errorMessage: [{ key: 'orderId', messages: ['Order not found'] }]
                    };

                    expect(_context19.t0).toEqual(expected);

                  case 12:
                  case 'end':
                    return _context19.stop();
                }
              }
            }, _callee19, undefined, [[1, 8]]);
          })));

        case 18:
        case 'end':
          return _context20.stop();
      }
    }
  }, _callee20, undefined);
})));

describe('Convert Ids into CSV string', function () {
  it('should response string', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee21() {
    var response;
    return regeneratorRuntime.wrap(function _callee21$(_context21) {
      while (1) {
        switch (_context21.prev = _context21.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
            _context21.next = 3;
            return (0, _Util.getCSVStringFromArrayObject)(_Config2.default.searchResult, _Config2.default.fieldName);

          case 3:
            response = _context21.sent;

            expect.stringContaining(response);

          case 5:
          case 'end':
            return _context21.stop();
        }
      }
    }, _callee21, undefined);
  })));
});

describe('Cancel Order', function () {
  it('Retrieve getOrderStatusReasonAsync, expect 404', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee22() {
    var statusId, response;
    return regeneratorRuntime.wrap(function _callee22$(_context22) {
      while (1) {
        switch (_context22.prev = _context22.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

            statusId = 11;
            _context22.prev = 2;
            _context22.next = 5;
            return (0, _Order.getOrderStatusReasonAsync)(statusId, token.accessToken);

          case 5:
            response = _context22.sent;

            expect('data' in response).toBeTruthy();
            _context22.next = 12;
            break;

          case 9:
            _context22.prev = 9;
            _context22.t0 = _context22['catch'](2);

            expect(_context22.t0).toHaveProperty('statusCode', 404);

          case 12:
          case 'end':
            return _context22.stop();
        }
      }
    }, _callee22, undefined, [[2, 9]]);
  })));

  it('Update orders status', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee23() {
    var orderId, payload;
    return regeneratorRuntime.wrap(function _callee23$(_context23) {
      while (1) {
        switch (_context23.prev = _context23.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
            orderId = 1;
            payload = {
              status_id: '11',
              order_status_reason_id: 0,
              notes: 'string'
            };
            _context23.prev = 3;
            _context23.next = 6;
            return (0, _Order.updateOrderStatus)(orderId, payload, token.accessToken);

          case 6:
            _context23.next = 11;
            break;

          case 8:
            _context23.prev = 8;
            _context23.t0 = _context23['catch'](3);

            expect(_context23.t0).toHaveProperty('statusCode', 404);

          case 11:
          case 'end':
            return _context23.stop();
        }
      }
    }, _callee23, undefined, [[3, 8]]);
  })));

  it('Split order to mutliple order status', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee24() {
    var orderId, payload;
    return regeneratorRuntime.wrap(function _callee24$(_context24) {
      while (1) {
        switch (_context24.prev = _context24.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
            orderId = 1;
            payload = {
              number_of_orders: 1
            };
            _context24.prev = 3;
            _context24.next = 6;
            return (0, _Order.splitToMultipleOrder)(orderId, payload, token.accessToken);

          case 6:
            _context24.next = 11;
            break;

          case 8:
            _context24.prev = 8;
            _context24.t0 = _context24['catch'](3);

            expect(_context24.t0).toHaveProperty('statusCode', 403);

          case 11:
          case 'end':
            return _context24.stop();
        }
      }
    }, _callee24, undefined, [[3, 8]]);
  })));
});

// TODO: needs to be fixed
/* test("Edit Multiple Grouping Locations not found", async () => {
  jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

  const result = getTokenAsync(
    CONFIG.email,
    CONFIG.password,
    CONFIG.clientId,
    CONFIG.clientSecret
  );
  const token = await result;

  try {
     const response = await editOrdersAsync(1,token.accessToken);
     expect("data" in response).toBeTruthy();
  } catch (error) {
console.log(error);
    const expected = {"errorMessage": [{"key": "0", "messages": "Grouping Location not found"}], "statusCode": 400, "statusText": "Bad Request"};
    expect(error).toEqual(expected);
  }
});*/

// TODO: needs to be fixed
/* test("Test for file uploading", async () => {
  jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

  const result = getTokenAsync(
    CONFIG.email,
    CONFIG.password,
    CONFIG.clientId,
    CONFIG.clientSecret
  );
  const token = await result;

  try {
    let formData = {};
    const response = await fileUploadForOrderAsync(
      {groupingSpreadsheet: formData},
      token.accessToken
    );

    expect("groupingBatchId" in response.data).toBeTruthy();
    expect(true).toBeTruthy();
    console.log(response);
  } catch (error) {
      console.log(error);
      expect(error).toHaveProperty("statusCode", 401);
  }
});*/

// TODO: needs to be fixed
/* test("Test for file uploading error", async () => {
  jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

  const response = await fileUploadForOrderAsync(
    {grouping_spreadsheet: 12},
    CONFIG.token
  );

  expect("error" in response).toBeTruthy();
});*/