'use strict';

var _momentTimezone = require('moment-timezone');

var _momentTimezone2 = _interopRequireDefault(_momentTimezone);

var _Util = require('../Util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

describe('Convert object key/value into url string', function () {
  it('should match the string values limit and offset', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var data, urlString;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

            data = {
              limit: 20,
              offset: 1
            };
            _context.next = 4;
            return (0, _Util.convertObjectIntoURLString)(data);

          case 4:
            urlString = _context.sent;

            expect(urlString).toMatch(/limit/);
            expect(urlString).toMatch(/offset/);

          case 7:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  })));
});

/* describe("Handle API Error", () => {
  it("should return promise (reject) object with statusCode, statusText and errorMessage", async () => {
    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

    const errors = {
      response: {
        statusCode: 400,
        statusText: "Bad Request",
        errorMessage: {
          email: ["Duplicate Email"],
        },
      },
    };
    const result = await apiResponseErrorHandler(errors);

    expect("statusCode" in result).toBeTruthy();
    expect("statusText" in result).toBeTruthy();
    expect("errorMessage" in result).toBeTruthy();
    expect.arrayContaining(result.errorMessage);
  });
});*/

/* describe("Response Promise Reject", () => {
  it("should return promise (reject) object with stausCode, statusText and errorMessage", async () => {
    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

    try {
      const errors = {
        response: {
          status: 400,
          statusText: "Bad Request",
          errorMessage: "Errror String",
        },
      };

      const result = await rejectPromise(errors);
      console.log(result);

      expect("statusCode" in result).toBeTruthy();
      expect("statusText" in result).toBeTruthy();
      expect("errorMessage" in result).toBeTruthy();
      } catch (error) {
      console.log(error);
      await expect(error).rejects.toHaveProperty("statusCode", 400);
    }
  });
});*/

/* describe("Format error messages into key value objects inside of array", () => {
  jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

  const errorMessage = {
    email: ["Duplicate Email"],
  };
  const expected = ["email", ["Duplicate Email"]];

  it("matches if the actual object contains expected key: value pairs", async () => {
    const result = getFormattedErrorArray(errorMessage);
    expect(result).toEqual(expect.objectContaining(expected));
  });
});*/

describe('Convert Object into key/value array.', function () {
  jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

  var errorMessage = {
    email: ['Duplicate Email']
  };
  var expected = [['email', ['Duplicate Email']]];

  it('matches if the actual object contains expected key: value pairs', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var result;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            result = (0, _Util.convertObjectIntoKeyValueArray)(errorMessage);

            expect(result).toEqual(expect.objectContaining(expected));

          case 2:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  })));
});

/* describe("Iterate the array and format by using ES 6 reduce method", () => {
  jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

  const data = [1, 2, 3];

  it("should response key/value elements inside of an array", async () => {
    const result = await arrayReduce(data, data.sort(), []);
    it("tests result value types correctly", () => {
      expect(result).toBeType("array");
    });
  });
});*/

/* describe("Store key/value element into array", () => {
  jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

  it("should response new array with key/value elements", async () => {
    const [key, value] = ["key", "messages"];

    const result = await pushKeyAndMessageToArray([], [key, value]);
    expect(result).toBe("array");
  });
});*/

/* describe("Check the same object id in two params", () => {
  jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

  it("true/false value in ", async () => {
    const objectA = {id: 1};
    const objectB = {id: 1};
    const result = await hasSameObjectId(objectA, objectB);
    expect(result).toBe("array");
  });
});*/

describe('Return error object from simple object', function () {
  jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

  it('should create error object ', function () {
    var object = { statusCode: 401, statusText: 'Unauthorized' };
    var result = (0, _Util.customError)(object);
    expect(result).toMatchSnapshot();
  });
});

describe('Union two arrays into one if ids are equal', function () {
  jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

  it('should merge test property of two arrays into one and return new array', function () {
    var a = [{ id: 1, test: [{ name: 'Bob' }] }];
    var b = [{ id: 1, test: [{ name: 'John' }] }];
    var union = [{ id: 1, test: [{ name: 'Bob' }, { name: 'John' }] }];
    var result = (0, _Util.mergeArraysWithObjects)(a, b, 'id', 'test');
    expect(Array.isArray(result)).toBeTruthy();
    expect(result).toHaveLength(1);
    expect(result).toEqual(union);
    expect(result[0].test).toHaveLength(2);
  });

  it('should return first argument array', function () {
    var a = [{ id: 1, test: [{ name: 'Bob' }] }];
    var b = [];
    var result = (0, _Util.mergeArraysWithObjects)(a, b, 'id', 'test');
    expect(result).toEqual(a);
  });

  it('should return second argument array', function () {
    var a = [];
    var b = [{ id: 1, test: [{ name: 'John' }] }];
    var result = (0, _Util.mergeArraysWithObjects)(a, b, 'id', 'test');
    expect(result).toEqual(b);
  });

  it('should return empty array', function () {
    var a = [];
    var b = [];
    var result = (0, _Util.mergeArraysWithObjects)(a, b, 'id', 'test');
    expect(result).toEqual([]);
  });
});

describe('Return proper UTC datetime based on moment in time and timezone', function () {
  jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

  it('convert timestamp', function () {
    var datetime = (0, _momentTimezone2.default)('2018-11-11 20:30').tz('Europe/Warsaw');
    var singaporeDateTime = (0, _Util.getUserDateTimeInTimezone)(datetime, 'Singapore');
    expect(singaporeDateTime.format('YYYY-MM-DD HH:mm')).toEqual(datetime.tz('Singapore').format('YYYY-MM-DD HH:mm'));
  });
});

// getUserDateTimefromUTC is DEPRECATED
describe('Return proper UTC datetime based on timezone and timestamp', function () {
  jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

  it('convert timestamp', function () {
    var timestamp = (0, _momentTimezone2.default)('2018-11-11 20:30').tz('Europe/Warsaw').unix();
    var mockedUserIdentityId = 1;
    var mockedIdentities = [{
      id: 1,
      identityDetail: {
        timezone: 'Singapore'
      }
    }];
    var utcDateTime = (0, _Util.getUserDateTimefromUTC)(timestamp, mockedUserIdentityId, mockedIdentities);
    expect(utcDateTime.format('YYYY-MM-DD HH:mm')).toEqual((0, _momentTimezone2.default)(timestamp * 1000).tz('Singapore').format('YYYY-MM-DD HH:mm'));
  });
});