'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.optimizeRouteAsync = undefined;

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _Endpoint = require('../data/Endpoint');

var _Endpoint2 = _interopRequireDefault(_Endpoint);

var _camelize = require('camelize');

var _camelize2 = _interopRequireDefault(_camelize);

var _Util = require('../data/utility/Util');

var _ChangeCase = require('../data/utility/ChangeCase');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * @fileoverview This file contains all Routing related functions that are triggered by a User
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */

// TODO: this file should be part of a seprate routing package in the future.

/**
 * Optimize route
 * @param {object} payload # {date, routeSettingId, routingScope}
 * date (mandatory)(string) = "2018-02-28" #pickupDate
 * routeSettingId (mandatory)(integer) = 124
 * routingScope (mandatory)(string) = "all"
 * @param {string} token
 * @return {object} Promise resolve/reject
 */
var optimizeRouteAsync = exports.optimizeRouteAsync = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var payload = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var token = arguments[1];
    var response;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return (0, _axios2.default)({
              method: 'POST',
              url: _Endpoint2.default.API_V3.OPTIMIZE_ROUTE,
              headers: {
                Authorization: 'Bearer ' + token,
                'Content-Type': 'application/json'
              },
              data: (0, _ChangeCase.camelToSnake)(payload)
            });

          case 3:
            response = _context.sent;
            return _context.abrupt('return', (0, _camelize2.default)(response.data));

          case 7:
            _context.prev = 7;
            _context.t0 = _context['catch'](0);
            return _context.abrupt('return', (0, _Util.apiResponseErrorHandler)(_context.t0));

          case 10:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[0, 7]]);
  }));

  return function optimizeRouteAsync() {
    return _ref.apply(this, arguments);
  };
}();