'use strict';

var _Auth = require('../../account/Auth');

var _BackgroundJob = require('../Background-Job');

var _Config = require('./Config');

var _Config2 = _interopRequireDefault(_Config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

/**
 * this function checkes the expected properies in job
 * @param {object} response
 */
function expectedJobProps(response) {
  expect('data' in response).toBeTruthy();

  var data = response.data;
  expect('backgroundJobTypeId' in data).toBeTruthy();
  expect('backgroundJobTypeName' in data).toBeTruthy();
  expect('backgroundJobStatusId' in data).toBeTruthy();
  expect('backgroundJobStatusName' in data).toBeTruthy();
  expect('userId' in data).toBeTruthy();
}

describe('Tests getLatestBackgroundJob function', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
  var token;
  return regeneratorRuntime.wrap(function _callee7$(_context7) {
    while (1) {
      switch (_context7.prev = _context7.next) {
        case 0:
          token = void 0;


          beforeAll(_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context.next = 3;
                    return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

                  case 3:
                    token = _context.sent;

                  case 4:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, undefined);
          })));

          it('should response object including 200 status when type is 1(Optimize Route)', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
            var response;
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    // type 1 is optimized routes
                    _context2.next = 3;
                    return (0, _BackgroundJob.getLatestBackgroundJob)(1, token.accessToken);

                  case 3:
                    response = _context2.sent;

                    expect('data' in response).toBeTruthy();

                    expectedJobProps(response);

                  case 6:
                  case 'end':
                    return _context2.stop();
                }
              }
            }, _callee2, undefined);
          })));

          it('should response object including 200 status when type is 2(Generate Driver Availability)', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
            var response;
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    // type 2 is Generate Driver Availability
                    _context3.next = 3;
                    return (0, _BackgroundJob.getLatestBackgroundJob)(2, token.accessToken);

                  case 3:
                    response = _context3.sent;

                    expectedJobProps(response);

                  case 5:
                  case 'end':
                    return _context3.stop();
                }
              }
            }, _callee3, undefined);
          })));

          it('should response object including 200 status when type is 3(Generate Driver Order Recommendations)', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
            var response;
            return regeneratorRuntime.wrap(function _callee4$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    // type 3 is Generate Driver Order Recommendations
                    _context4.next = 3;
                    return (0, _BackgroundJob.getLatestBackgroundJob)(3, token.accessToken);

                  case 3:
                    response = _context4.sent;

                    expectedJobProps(response);

                  case 5:
                  case 'end':
                    return _context4.stop();
                }
              }
            }, _callee4, undefined);
          })));

          it('should response error including 401', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
            return regeneratorRuntime.wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context5.prev = 1;
                    _context5.next = 4;
                    return (0, _BackgroundJob.getLatestBackgroundJob)(3, '1234');

                  case 4:
                    _context5.next = 9;
                    break;

                  case 6:
                    _context5.prev = 6;
                    _context5.t0 = _context5['catch'](1);

                    expect(_context5.t0).toHaveProperty('statusCode', 401);

                  case 9:
                  case 'end':
                    return _context5.stop();
                }
              }
            }, _callee5, undefined, [[1, 6]]);
          })));

          it('should response error including 400', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
            return regeneratorRuntime.wrap(function _callee6$(_context6) {
              while (1) {
                switch (_context6.prev = _context6.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    // id 4 is passed which is a validation error
                    _context6.prev = 1;
                    _context6.next = 4;
                    return (0, _BackgroundJob.getLatestBackgroundJob)(4, token.accessToken);

                  case 4:
                    _context6.next = 9;
                    break;

                  case 6:
                    _context6.prev = 6;
                    _context6.t0 = _context6['catch'](1);

                    expect(_context6.t0).toHaveProperty('statusCode', 400);

                  case 9:
                  case 'end':
                    return _context6.stop();
                }
              }
            }, _callee6, undefined, [[1, 6]]);
          })));

        case 7:
        case 'end':
          return _context7.stop();
      }
    }
  }, _callee7, undefined);
})));