'use strict';

var _Route = require('../Route');

var _Auth = require('../../account/Auth');

var _Config = require('./Config.js');

var _Config2 = _interopRequireDefault(_Config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

describe('Remove Route', function () {
  it('should return 401 not authorized', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var result;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

            _context.prev = 1;
            _context.next = 4;
            return (0, _Route.removeRouteAsync)(_Config2.default.routeId, _Config2.default.token);

          case 4:
            result = _context.sent;

            expect('data' in result).toBeTruthy();
            expect(result.data).toBeTruthy();
            _context.next = 12;
            break;

          case 9:
            _context.prev = 9;
            _context.t0 = _context['catch'](1);

            expect(_context.t0).toHaveProperty('statusCode', 401);

          case 12:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[1, 9]]);
  })));
});

it('should test storeRouteAsync get statusCode 401', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
  var payload;
  return regeneratorRuntime.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
          payload = {
            routes: _Config2.default.createRoutePayload,
            replaceAllExisting: true
          };
          _context2.prev = 2;
          _context2.next = 5;
          return (0, _Route.storeRouteAsync)(payload, '');

        case 5:
          _context2.next = 10;
          break;

        case 7:
          _context2.prev = 7;
          _context2.t0 = _context2['catch'](2);

          expect(_context2.t0).toHaveProperty('statusCode', 401);

        case 10:
        case 'end':
          return _context2.stop();
      }
    }
  }, _callee2, undefined, [[2, 7]]);
})));

it('should test storeRouteAsync get statusCode 400', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
  var _ref4, accessToken;

  return regeneratorRuntime.wrap(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
          _context3.next = 3;
          return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

        case 3:
          _ref4 = _context3.sent;
          accessToken = _ref4.accessToken;
          _context3.prev = 5;
          _context3.next = 8;
          return (0, _Route.storeRouteAsync)({}, accessToken);

        case 8:
          _context3.next = 13;
          break;

        case 10:
          _context3.prev = 10;
          _context3.t0 = _context3['catch'](5);

          expect(_context3.t0).toHaveProperty('statusCode', 400);

        case 13:
        case 'end':
          return _context3.stop();
      }
    }
  }, _callee3, undefined, [[5, 10]]);
})));

it('should test update routed order', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
  var requestedData, routeId, routeLocationId, orderId, _ref6, accessToken;

  return regeneratorRuntime.wrap(function _callee4$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

          requestedData = {};
          routeId = 1;
          routeLocationId = 1;
          orderId = 1;
          _context4.next = 7;
          return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

        case 7:
          _ref6 = _context4.sent;
          accessToken = _ref6.accessToken;
          _context4.prev = 9;
          _context4.next = 12;
          return (0, _Route.updateRoutedOrder)(requestedData, routeId, routeLocationId, orderId, accessToken);

        case 12:
          _context4.next = 17;
          break;

        case 14:
          _context4.prev = 14;
          _context4.t0 = _context4['catch'](9);

          expect(_context4.t0).toHaveProperty('statusCode', 404);

        case 17:
        case 'end':
          return _context4.stop();
      }
    }
  }, _callee4, undefined, [[9, 14]]);
})));

it('should test to recalculate route', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
  var routeId, _ref8, accessToken;

  return regeneratorRuntime.wrap(function _callee5$(_context5) {
    while (1) {
      switch (_context5.prev = _context5.next) {
        case 0:
          jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

          routeId = 1;
          _context5.next = 4;
          return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

        case 4:
          _ref8 = _context5.sent;
          accessToken = _ref8.accessToken;
          _context5.prev = 6;
          _context5.next = 9;
          return (0, _Route.recalculateRouteOrder)(routeId, accessToken);

        case 9:
          _context5.next = 14;
          break;

        case 11:
          _context5.prev = 11;
          _context5.t0 = _context5['catch'](6);

          expect(_context5.t0).toHaveProperty('statusCode', 404);

        case 14:
        case 'end':
          return _context5.stop();
      }
    }
  }, _callee5, undefined, [[6, 11]]);
})));

it('should test to get route location order', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
  var routeId, routeLocationId, _ref10, accessToken;

  return regeneratorRuntime.wrap(function _callee6$(_context6) {
    while (1) {
      switch (_context6.prev = _context6.next) {
        case 0:
          jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

          routeId = 1001;
          routeLocationId = 10001;
          _context6.next = 5;
          return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

        case 5:
          _ref10 = _context6.sent;
          accessToken = _ref10.accessToken;
          _context6.prev = 7;
          _context6.next = 10;
          return (0, _Route.getRouteLocationOrder)(routeId, routeLocationId, accessToken);

        case 10:
          _context6.next = 15;
          break;

        case 12:
          _context6.prev = 12;
          _context6.t0 = _context6['catch'](7);

          expect(_context6.t0).toHaveProperty('statusCode', 404);

        case 15:
        case 'end':
          return _context6.stop();
      }
    }
  }, _callee6, undefined, [[7, 12]]);
})));

it('should test to get order draft details', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
  var routeId, routeLocationId, orderId, filterObj, _ref12, accessToken;

  return regeneratorRuntime.wrap(function _callee7$(_context7) {
    while (1) {
      switch (_context7.prev = _context7.next) {
        case 0:
          jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

          routeId = 1001;
          routeLocationId = 10001;
          orderId = 111111;
          filterObj = {};
          _context7.next = 7;
          return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

        case 7:
          _ref12 = _context7.sent;
          accessToken = _ref12.accessToken;
          _context7.prev = 9;
          _context7.next = 12;
          return (0, _Route.getRouteDraftDetails)(routeId, routeLocationId, orderId, filterObj, accessToken);

        case 12:
          _context7.next = 17;
          break;

        case 14:
          _context7.prev = 14;
          _context7.t0 = _context7['catch'](9);

          expect(_context7.t0).toHaveProperty('statusCode', 404);

        case 17:
        case 'end':
          return _context7.stop();
      }
    }
  }, _callee7, undefined, [[9, 14]]);
})));