'use strict';

var _Auth = require('../../account/Auth');

var _Setting = require('../Setting');

var _Config = require('./Config');

var _Config2 = _interopRequireDefault(_Config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

describe('Test getUserSettingsAsync function', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
  var token;
  return regeneratorRuntime.wrap(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          token = void 0;


          beforeAll(_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context.next = 3;
                    return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

                  case 3:
                    token = _context.sent;

                  case 4:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, undefined);
          })));

          it('should return user settings status 200', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
            var response;
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context2.prev = 1;
                    _context2.next = 4;
                    return (0, _Setting.getUserSettingsAsync)(token.accessToken);

                  case 4:
                    response = _context2.sent;

                    expect(response).toMatchSnapshot();
                    _context2.next = 11;
                    break;

                  case 8:
                    _context2.prev = 8;
                    _context2.t0 = _context2['catch'](1);

                    expect(_context2.t0).toHaveProperty('statusCode');

                  case 11:
                  case 'end':
                    return _context2.stop();
                }
              }
            }, _callee2, undefined, [[1, 8]]);
          })));

        case 3:
        case 'end':
          return _context3.stop();
      }
    }
  }, _callee3, undefined);
})));

describe('Test getUserSettingMyOrdersColumnAsync function', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
  var token;
  return regeneratorRuntime.wrap(function _callee6$(_context6) {
    while (1) {
      switch (_context6.prev = _context6.next) {
        case 0:
          token = void 0;


          beforeAll(_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
            return regeneratorRuntime.wrap(function _callee4$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context4.next = 3;
                    return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

                  case 3:
                    token = _context4.sent;

                  case 4:
                  case 'end':
                    return _context4.stop();
                }
              }
            }, _callee4, undefined);
          })));

          it('should get user settings', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
            var response;
            return regeneratorRuntime.wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context5.prev = 1;
                    _context5.next = 4;
                    return (0, _Setting.getUserSettingMyOrdersColumnAsync)(token.accessToken);

                  case 4:
                    response = _context5.sent;

                    expect(response.data).toMatchSnapshot();
                    _context5.next = 11;
                    break;

                  case 8:
                    _context5.prev = 8;
                    _context5.t0 = _context5['catch'](1);

                    expect(_context5.t0).toHaveProperty('statusCode');

                  case 11:
                  case 'end':
                    return _context5.stop();
                }
              }
            }, _callee5, undefined, [[1, 8]]);
          })));

        case 3:
        case 'end':
          return _context6.stop();
      }
    }
  }, _callee6, undefined);
})));

describe('test updating user settings', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
  var token;
  return regeneratorRuntime.wrap(function _callee9$(_context9) {
    while (1) {
      switch (_context9.prev = _context9.next) {
        case 0:
          token = void 0;

          beforeAll(_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
            return regeneratorRuntime.wrap(function _callee7$(_context7) {
              while (1) {
                switch (_context7.prev = _context7.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context7.next = 3;
                    return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

                  case 3:
                    token = _context7.sent;

                  case 4:
                  case 'end':
                    return _context7.stop();
                }
              }
            }, _callee7, undefined);
          })));

          it('should return 200', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
            var response;
            return regeneratorRuntime.wrap(function _callee8$(_context8) {
              while (1) {
                switch (_context8.prev = _context8.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context8.next = 3;
                    return (0, _Setting.putUserSettingMyOrdersColumn)([{
                      key: 'customerOrderNumber',
                      isFixed: false,
                      isVisible: true
                    }], token.accessToken);

                  case 3:
                    response = _context8.sent;


                    expect(response).toHaveProperty('status', 200);
                    expect(response.data).toHaveProperty('myOrdersColumns', [{ isFixed: false, isVisible: true, key: 'customerOrderNumber' }]);
                    expect(response.data.myOrdersColumns[0]).toHaveProperty('isVisible', true);

                  case 7:
                  case 'end':
                    return _context8.stop();
                }
              }
            }, _callee8, undefined);
          })));

        case 3:
        case 'end':
          return _context9.stop();
      }
    }
  }, _callee9, undefined);
})));