'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getExportURL = exports.exportFileAsync = undefined;

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _Endpoint = require('../Endpoint');

var _Endpoint2 = _interopRequireDefault(_Endpoint);

var _camelize = require('camelize');

var _camelize2 = _interopRequireDefault(_camelize);

var _Util = require('../utility/Util');

var _ChangeCase = require('../utility/ChangeCase');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * @fileoverview This file contains all Export related functions that are triggered by a Customer
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */

// TODO: this file should be moved to /Customer since they are always triggered by a Customer

/** Export File
 * @param {string} type (mandatory) # driver-list or routing
 * @param {string} payload {transactionGroupIds, recipientEmail, pickupDate}
 * transactionGroupIds (optional) (array)
 * recipientEmail (optional) (string)
 * pickupDate (optional) (string) #Pickupdate is mandatory if type is routing
 * @param {string} token
 * @return {object} promist (reject/resolve)
 */
var exportFileAsync = exports.exportFileAsync = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(type, payload, token) {
    var response;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return (0, _axios2.default)({
              method: 'POST',
              url: getExportURL(type),
              headers: { Authorization: 'Bearer ' + token },
              data: (0, _ChangeCase.camelToSnake)(payload)
            });

          case 3:
            response = _context.sent;
            return _context.abrupt('return', (0, _camelize2.default)(response));

          case 7:
            _context.prev = 7;
            _context.t0 = _context['catch'](0);
            return _context.abrupt('return', (0, _Util.apiResponseErrorHandler)(_context.t0));

          case 10:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[0, 7]]);
  }));

  return function exportFileAsync(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

/** Get export endpoint url
 * @param {string} type (mandatory)
 * @return {string} url
 */
var getExportURL = exports.getExportURL = function getExportURL(type) {
  switch (type) {
    case 'driver-list':
      return _Endpoint2.default.API_V3.EXPORT_DRIVER_LIST;
    case 'customer-list':
      return _Endpoint2.default.API_V3.EXPORT_CUSTOMER_LIST;
    case 'order-analytics':
      return _Endpoint2.default.API_V3.EXPORT_ORDER_ANALYTICS;
    case 'routing':
      return _Endpoint2.default.API_V3.EXPORT_ROUTE;
    default:
      return _Endpoint2.default.API_V3.EXPORT_ROUTE;
  }
};