'use strict';

var _Depot = require('../Depot');

var _Auth = require('../../account/Auth');

var _Config = require('./Config');

var _Config2 = _interopRequireDefault(_Config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

describe('should show the list of depots', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
  return regeneratorRuntime.wrap(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

          it('Should get Depots list', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
            var token, response;
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.prev = 0;
                    _context.next = 3;
                    return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

                  case 3:
                    token = _context.sent;
                    _context.next = 6;
                    return (0, _Depot.getDepotsAsync)(token.accessToken);

                  case 6:
                    response = _context.sent;

                    expect('data' in response).toBeTruthy();
                    _context.next = 13;
                    break;

                  case 10:
                    _context.prev = 10;
                    _context.t0 = _context['catch'](0);

                    expect(_context.t0).toHaveProperty('statusCode', 404);

                  case 13:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, undefined, [[0, 10]]);
          })));

          it('Should get auth error if there is no proper token', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
            var response;
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    _context2.prev = 0;
                    _context2.next = 3;
                    return (0, _Depot.getDepotsAsync)('123');

                  case 3:
                    response = _context2.sent;

                    expect('data' in response).toBeTruthy();
                    _context2.next = 10;
                    break;

                  case 7:
                    _context2.prev = 7;
                    _context2.t0 = _context2['catch'](0);

                    expect(_context2.t0).toHaveProperty('statusCode', 401);

                  case 10:
                  case 'end':
                    return _context2.stop();
                }
              }
            }, _callee2, undefined, [[0, 7]]);
          })));

        case 3:
        case 'end':
          return _context3.stop();
      }
    }
  }, _callee3, undefined);
})));

describe('Depot creation', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
  return regeneratorRuntime.wrap(function _callee5$(_context5) {
    while (1) {
      switch (_context5.prev = _context5.next) {
        case 0:
          it('Should create a new depot', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
            var token, data, response;
            return regeneratorRuntime.wrap(function _callee4$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    _context4.prev = 0;
                    _context4.next = 3;
                    return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

                  case 3:
                    token = _context4.sent;
                    data = {
                      code: 'depot-' + Math.floor(Math.random() * (999 - 100 + 1) + 100),
                      operating_time_start: '06:00',
                      operating_time_end: '20:00',
                      start_service_time_in_seconds: 1800,
                      renewal_service_time_in_seconds: 1800,
                      end_service_time_in_seconds: 1800,
                      location: {
                        address: '70 Anson Road, Singapore, 079905',
                        building_name: 'GB Building',
                        unit_number: '#01-23',
                        latitude: 1.31384,
                        longitude: 103.8071591
                      },
                      contact: {
                        name: 'Joe Dohn',
                        email: 'joed@carpal.me',
                        phone: '+6587654321',
                        company_name: 'CarPal SG'
                      }
                    };
                    _context4.next = 7;
                    return (0, _Depot.createDepotAsync)(token.accessToken, data);

                  case 7:
                    response = _context4.sent;

                    expect('data' in response).toBeTruthy();
                    _context4.next = 14;
                    break;

                  case 11:
                    _context4.prev = 11;
                    _context4.t0 = _context4['catch'](0);

                    expect(_context4.t0).toHaveProperty('statusCode', 400 || 404);

                  case 14:
                  case 'end':
                    return _context4.stop();
                }
              }
            }, _callee4, undefined, [[0, 11]]);
          })));

        case 1:
        case 'end':
          return _context5.stop();
      }
    }
  }, _callee5, undefined);
})));