'use strict';

var _ServiceProvider = require('../ServiceProvider');

var _Config = require('./Config.js');

var _Config2 = _interopRequireDefault(_Config);

var _Auth = require('../../account/Auth');

var _Util = require('../../utility/Util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

describe('Test for Service Provider', function () {
  beforeEach(function () {
    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
  });

  it('should get service provider customer', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var _ref2, accessToken, params, result;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

          case 2:
            _ref2 = _context.sent;
            accessToken = _ref2.accessToken;
            _context.prev = 4;
            params = {
              keyword: 'a',
              offset: 0,
              limit: 1
            };
            _context.next = 8;
            return (0, _ServiceProvider.searchServiceProviderCustomerAsync)(params, accessToken);

          case 8:
            result = _context.sent;

            expect(result).toBeTruthy();
            _context.next = 15;
            break;

          case 12:
            _context.prev = 12;
            _context.t0 = _context['catch'](4);

            expect(_context.t0).toHaveProperty('statusCode', 403);

          case 15:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[4, 12]]);
  })));

  it('should get service provider details by its id response', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var _ref4, accessToken, result, mockError;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

          case 2:
            _ref4 = _context2.sent;
            accessToken = _ref4.accessToken;
            _context2.prev = 4;
            _context2.next = 7;
            return (0, _ServiceProvider.getServiceProviderAsync)(10001, accessToken);

          case 7:
            result = _context2.sent;

            expect(result.length).toBeTruthy();
            _context2.next = 15;
            break;

          case 11:
            _context2.prev = 11;
            _context2.t0 = _context2['catch'](4);
            mockError = (0, _Util.apiResponseErrorHandler)(_context2.t0);

            expect(mockError).toEqual(Promise.reject(_context2.t0));

          case 15:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined, [[4, 11]]);
  })));
});