'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handlerConnectionError = exports.checkConnection = exports.sendMessageToMainThread = undefined;

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _endpoints = require('./endpoints');

var _endpoints2 = _interopRequireDefault(_endpoints);

var _Util = require('../utility/Util');

var _worker = require('worker');

var _worker2 = _interopRequireDefault(_worker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

// TODO: consider deprecating all functions below as they are not implemented properly
// TODO: there are no unit tests

/* self.onmessage = (e) => {
  let interval = new Interval(
    checkConnection.bind(null, e),
    e.data.checkingTime
  );
  switch (e.data.event) {
    case "startJob":
      interval.start(e);
      break;
    case "stopJob":
      self.stop();
      interval.stop();
      break;
  }
};*/

var sendMessageToMainThread = exports.sendMessageToMainThread = function sendMessageToMainThread(e) {
  _worker2.default.postMessage({ errorCounts: e.data.errorCounts, event: 'finishedJob' });
};

var checkConnection = exports.checkConnection = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(e) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _axios2.default)({
              method: 'GET',
              // TODO: endpoint does not exist
              url: _endpoints2.default.CHECK_SOCKET_CONNECTION,
              header: { Authorization: e.data.token }
            });

          case 2:
            e.data.errorCounts = 0;
            sendMessageToMainThread(e, true);

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function checkConnection(_x) {
    return _ref.apply(this, arguments);
  };
}();

/**
 * Handle Notification Error
 * @param {object} e
 * @return {object} Promise.reject with statusCode and statusText
 */
var handlerConnectionError = exports.handlerConnectionError = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(e) {
    var payload;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;

            e.data.errorCounts += 1;
            payload = {
              slackChannel: '',
              channelId: e.data.channelId,
              eventName: 'error.pubsub', // OR error.network
              message: e.response.statusText
            };
            _context2.next = 5;
            return (0, _axios2.default)({
              method: 'GET',
              // TODO: endpoint does not exist
              url: _endpoints2.default.SEND_NOTI_TO_SLACK,
              header: { Authorization: e.data.token },
              body: payload
            });

          case 5:
            return _context2.abrupt('return', sendMessageToMainThread(e));

          case 8:
            _context2.prev = 8;
            _context2.t0 = _context2['catch'](0);

            (0, _Util.rejectPromise)(_context2.t0);

          case 11:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined, [[0, 8]]);
  }));

  return function handlerConnectionError(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

/**
 * Interval
 * @param {function} fn
 * @param {int} time
 */
/* export const Interval = (fn, time) => {
  let timer = false;

  let start = function() {
    if (!isRunning()) timer = setInterval(fn, time);
  };

  let stop = function() {
    clearInterval(timer);
    timer = false;
  };

  let isRunning = function() {
    return timer !== false;
  };
};*/