'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getReportFieldsAsync = undefined;

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _Endpoint = require('../Endpoint');

var _Endpoint2 = _interopRequireDefault(_Endpoint);

var _camelize = require('camelize');

var _camelize2 = _interopRequireDefault(_camelize);

var _Util = require('../utility/Util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * @fileoverview This file contains all getReportFieldsAsync related functions that are triggered by a (public) User
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */

/**
 * Retrieve all report fields
 * @param {string} reportType
 * @return {object} Promise resolve/reject
 */
var getReportFieldsAsync = exports.getReportFieldsAsync = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(reportType) {
    var response;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return _axios2.default.get(_Endpoint2.default.API_V3.REPORT_FIELDS.replace('{0}', reportType));

          case 3:
            response = _context.sent;
            return _context.abrupt('return', (0, _camelize2.default)(response.data.data));

          case 7:
            _context.prev = 7;
            _context.t0 = _context['catch'](0);
            return _context.abrupt('return', (0, _Util.apiResponseErrorHandler)(_context.t0));

          case 10:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[0, 7]]);
  }));

  return function getReportFieldsAsync(_x) {
    return _ref.apply(this, arguments);
  };
}();