'use strict';

var _Account = require('../Account');

var _Config = require('./Config');

var _Config2 = _interopRequireDefault(_Config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

describe('Request reset password token', function () {
  it('should repond true with 204', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var response;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 20000;

            _context.prev = 1;
            _context.next = 4;
            return (0, _Account.resetPasswordRequestAsync)(_Config2.default.email);

          case 4:
            response = _context.sent;

            expect(response).toHaveProperty('status', 204);
            _context.next = 11;
            break;

          case 8:
            _context.prev = 8;
            _context.t0 = _context['catch'](1);

            expect(_context.t0).toHaveProperty('statusCode', 400);

          case 11:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[1, 8]]);
  })));

  it('should repond true with 400', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var response;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 20000;

            _context2.prev = 1;
            _context2.next = 4;
            return (0, _Account.resetPasswordRequestAsync)('test');

          case 4:
            response = _context2.sent;

            expect(response).toBeTruthy();
            _context2.next = 11;
            break;

          case 8:
            _context2.prev = 8;
            _context2.t0 = _context2['catch'](1);

            expect(_context2.t0).toHaveProperty('statusCode', 400);

          case 11:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined, [[1, 8]]);
  })));
});

describe('Reset password with token', function () {
  test('resetPasswordAsync throw 400 because of no or invalid token', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 20000;

            _context3.prev = 1;
            _context3.next = 4;
            return (0, _Account.resetPasswordAsync)(undefined, _Config2.default.email, 'carpaldemo', 'carpaldemo');

          case 4:
            _context3.next = 9;
            break;

          case 6:
            _context3.prev = 6;
            _context3.t0 = _context3['catch'](1);

            expect(_context3.t0).toHaveProperty('statusCode', 400);

          case 9:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined, [[1, 6]]);
  })));
});

describe('Test for reset password token validation', function () {
  test('reject with statusCode 404 if the reset token is not found', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
    var result;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 20000;

            _context4.prev = 1;
            _context4.next = 4;
            return (0, _Account.validateResetPasswordTokenAsync)(12);

          case 4:
            result = _context4.sent;

            expect(result).toHaveProperty('statusCode', 204);
            _context4.next = 11;
            break;

          case 8:
            _context4.prev = 8;
            _context4.t0 = _context4['catch'](1);

            expect(_context4.t0).toHaveProperty('statusCode', 404);

          case 11:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined, [[1, 8]]);
  })));
});