'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _Job = require('../Job');

var _Auth = require('../../account/Auth');

var _Config = require('./Config');

var _Config2 = _interopRequireDefault(_Config);

var _Route = require('../Route');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

// This test needs to be updated with the current implementation
// const testMethodWithJobId = async (methodName) => {
//   const token = await getTokenAsync(
//     CONFIG.email,
//     CONFIG.password,
//     CONFIG.clientId,
//     CONFIG.clientSecret
//   );
//
//   const routePayload = {
//     driverId: 11997,
//     pickupDate: CONFIG.jobTest.date,
//     route_settings: '{}',
//   };
//
//   const route1Res = await storeRouteAsync(
//     {
//       routes: [
//         {
//           ...routePayload,
//           routeLocations: [
//             {
//               sequence: 1,
//               orderId: CONFIG.jobTest.orderIds[0],
//               locationTypeId: 3,
//             },
//             {
//               sequence: 2,
//               orderId: CONFIG.jobTest.orderIds[0],
//               locationTypeId: 2,
//             },
//           ],
//         },
//       ],
//       replaceAllExisting: false,
//     },
//     token.accessToken
//   );
//
//   const route1 = route1Res.data[0];
//   const jobs = await createJobsAsync(`${route1.id}`, token.accessToken);
//
//   try {
//     const response = await methodName(jobs[0].job.id, token.accessToken);
//     expect('data' in response).toBeTruthy();
//   } catch (e) {
//     expect(e).toHaveProperty('statusCode', 404);
//   } finally {
//     await removeJobsAsync(jobs[0].job.id, token.accessToken);
//   }
// };

describe('should show job driver locations', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
  return regeneratorRuntime.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

          // it('Should get job driver locations data', () =>
          //   testMethodWithJobId(getJobDriverLocationsAsync));

          it('Should get auth error if there is no proper token', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
            var response;
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.prev = 0;
                    _context.next = 3;
                    return (0, _Job.getJobDriverLocationsAsync)(_Config2.default.orderId, '123');

                  case 3:
                    response = _context.sent;

                    expect('data' in response).toBeTruthy();
                    _context.next = 10;
                    break;

                  case 7:
                    _context.prev = 7;
                    _context.t0 = _context['catch'](0);

                    expect(_context.t0).toHaveProperty('statusCode', 401);

                  case 10:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, undefined, [[0, 7]]);
          })));

        case 2:
        case 'end':
          return _context2.stop();
      }
    }
  }, _callee2, undefined);
})));

describe('should show job timeline', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
  return regeneratorRuntime.wrap(function _callee4$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

          // it('Should get job timeline data', () =>
          //   testMethodWithJobId(getJobTimelineAsync));

          it('Should get auth error if there is no proper token', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
            var response;
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    _context3.prev = 0;
                    _context3.next = 3;
                    return (0, _Job.getJobTimelineAsync)(_Config2.default.orderId, '123');

                  case 3:
                    response = _context3.sent;

                    expect('data' in response).toBeTruthy();
                    _context3.next = 10;
                    break;

                  case 7:
                    _context3.prev = 7;
                    _context3.t0 = _context3['catch'](0);

                    expect(_context3.t0).toHaveProperty('statusCode', 401);

                  case 10:
                  case 'end':
                    return _context3.stop();
                }
              }
            }, _callee3, undefined, [[0, 7]]);
          })));

        case 2:
        case 'end':
          return _context4.stop();
      }
    }
  }, _callee4, undefined);
})));

// Need to update the current implementation
// describe('should show the list of customers jobs', async () => {
//   jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
//
//   it('Should get Jobs list', async () => {
//     try {
//       const token = await getTokenAsync(
//         CONFIG.email,
//         CONFIG.password,
//         CONFIG.clientId,
//         CONFIG.clientSecret
//       );
//       const response = await getJobsAsync(token.accessToken);
//       expect('data' in response).toBeTruthy();
//     } catch (error) {
//       expect(error).toHaveProperty('statusCode', 404);
//     }
//   });
//
//   it('Should get auth error if there is no proper token', async () => {
//     try {
//       const response = await getJobsAsync('123');
//       expect('data' in response).toBeTruthy();
//     } catch (error) {
//       expect(error).toHaveProperty('statusCode', 401);
//     }
//   });
// });

describe('Show job', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
  var token;
  return regeneratorRuntime.wrap(function _callee8$(_context8) {
    while (1) {
      switch (_context8.prev = _context8.next) {
        case 0:
          token = void 0;

          beforeAll(_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
            return regeneratorRuntime.wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
                    _context5.next = 3;
                    return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

                  case 3:
                    token = _context5.sent;

                  case 4:
                  case 'end':
                    return _context5.stop();
                }
              }
            }, _callee5, undefined);
          })));

          it('Should get Job summary and expect job not found', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
            var response;
            return regeneratorRuntime.wrap(function _callee6$(_context6) {
              while (1) {
                switch (_context6.prev = _context6.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context6.prev = 1;
                    _context6.next = 4;
                    return (0, _Job.getJobSummaryAsync)(_Config2.default.orderId, token.accessToken);

                  case 4:
                    response = _context6.sent;

                    expect('data' in response).toBeTruthy();
                    _context6.next = 10;
                    break;

                  case 8:
                    _context6.prev = 8;
                    _context6.t0 = _context6['catch'](1);

                  case 10:
                  case 'end':
                    return _context6.stop();
                }
              }
            }, _callee6, undefined, [[1, 8]]);
          }))
          // expect(error).toHaveProperty("statusCode", 404);
          // TODO: expect 404 according to documentation, but API is returning 403 because error is not handled properly
          );

          it('Should get job details and expect job not found', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
            var response;
            return regeneratorRuntime.wrap(function _callee7$(_context7) {
              while (1) {
                switch (_context7.prev = _context7.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    _context7.prev = 1;
                    _context7.next = 4;
                    return (0, _Job.getJobDetailAsync)(_Config2.default.orderId, token.accessToken);

                  case 4:
                    response = _context7.sent;

                    expect('data' in response).toBeTruthy();
                    _context7.next = 10;
                    break;

                  case 8:
                    _context7.prev = 8;
                    _context7.t0 = _context7['catch'](1);

                  case 10:
                  case 'end':
                    return _context7.stop();
                }
              }
            }, _callee7, undefined, [[1, 8]]);
          }))
          // console.log(error);
          // expect(error).toHaveProperty("statusCode", 404);
          // TODO: expect 404 according to documentation, but API is returning 403 because error is not handled properly
          );

        case 4:
        case 'end':
          return _context8.stop();
      }
    }
  }, _callee8, undefined);
})));

describe('job create and delete test', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee18() {
  var token, routePayload, route1, route2, routeIds, job1, job2, route1Res, route2Res;
  return regeneratorRuntime.wrap(function _callee18$(_context18) {
    while (1) {
      switch (_context18.prev = _context18.next) {
        case 0:
          jasmine.DEFAULT_TIMEOUT_INTERVAL = 90000;
          token = void 0;
          routePayload = void 0;
          route1 = void 0;
          route2 = void 0;
          routeIds = void 0;
          job1 = void 0;
          job2 = void 0;
          _context18.next = 10;
          return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

        case 10:
          token = _context18.sent;


          routePayload = {
            driverId: 11997,
            pickupDate: _Config2.default.jobTest.date,
            route_settings: '{}'
          };

          // create route 1 now
          _context18.next = 14;
          return (0, _Route.storeRouteAsync)({
            routes: [_extends({}, routePayload, {
              routeLocations: [{
                sequence: 1,
                orderId: _Config2.default.jobTest.orderIds[0],
                locationTypeId: 3
              }, {
                sequence: 2,
                orderId: _Config2.default.jobTest.orderIds[0],
                locationTypeId: 2
              }]
            })],
            replaceAllExisting: false
          }, token.accessToken);

        case 14:
          route1Res = _context18.sent;

          route1 = route1Res.data[0];

          _context18.next = 18;
          return (0, _Route.storeRouteAsync)({
            routes: [_extends({}, routePayload, {
              driverId: 12030,
              routeLocations: [{
                sequence: 1,
                orderId: _Config2.default.jobTest.orderIds[1],
                locationTypeId: 3
              }, {
                sequence: 2,
                orderId: _Config2.default.jobTest.orderIds[1],
                locationTypeId: 2
              }]
            })],
            replaceAllExisting: false
          }, token.accessToken);

        case 18:
          route2Res = _context18.sent;

          route2 = route2Res.data[0];

          routeIds = route1.id + ',' + route2.id;

          it('Should create a job', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
            var response;
            return regeneratorRuntime.wrap(function _callee9$(_context9) {
              while (1) {
                switch (_context9.prev = _context9.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 30000;
                    response = void 0;
                    _context9.prev = 2;
                    _context9.next = 5;
                    return (0, _Job.createJobsAsync)(routeIds, token.accessToken);

                  case 5:
                    response = _context9.sent;

                  case 6:
                    _context9.prev = 6;

                    expect(response).toHaveLength(2);
                    expect('job' in response[0]).toBeTruthy();
                    expect('job' in response[1]).toBeTruthy();
                    job1 = response[0].job;
                    job2 = response[1].job;
                    expect('id' in job1).toBeTruthy();
                    expect('id' in job2).toBeTruthy();
                    return _context9.finish(6);

                  case 15:
                  case 'end':
                    return _context9.stop();
                }
              }
            }, _callee9, undefined, [[2,, 6, 15]]);
          })));

          it('should delete the jobs', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10() {
            var response;
            return regeneratorRuntime.wrap(function _callee10$(_context10) {
              while (1) {
                switch (_context10.prev = _context10.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 30000;
                    response = void 0;
                    _context10.prev = 2;
                    _context10.next = 5;
                    return (0, _Job.removeJobsAsync)(job1.id + ',' + job2.id, token.accessToken);

                  case 5:
                    response = _context10.sent;

                  case 6:
                    _context10.prev = 6;

                    expect('data' in response).toBeTruthy();
                    return _context10.finish(6);

                  case 9:
                  case 'end':
                    return _context10.stop();
                }
              }
            }, _callee10, undefined, [[2,, 6, 9]]);
          })));

          it('create job should fail with status 400 when routeIds does not exists', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11() {
            var errorResponse, expected;
            return regeneratorRuntime.wrap(function _callee11$(_context11) {
              while (1) {
                switch (_context11.prev = _context11.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 30000;
                    errorResponse = null;
                    _context11.prev = 2;
                    _context11.next = 5;
                    return (0, _Job.createJobsAsync)('1234,4567', token.accessToken);

                  case 5:
                    _context11.next = 10;
                    break;

                  case 7:
                    _context11.prev = 7;
                    _context11.t0 = _context11['catch'](2);

                    errorResponse = _context11.t0;

                  case 10:
                    _context11.prev = 10;
                    expected = {
                      statusCode: 400,
                      statusText: 'Bad Request',
                      message: 'Bad Request',
                      errorMessage: [{
                        key: 'routeId',
                        messages: ['Route does not belong to you']
                      }]
                    };

                    expect(errorResponse).toEqual(expected);
                    return _context11.finish(10);

                  case 14:
                  case 'end':
                    return _context11.stop();
                }
              }
            }, _callee11, undefined, [[2, 7, 10, 14]]);
          })));

          it('remove job should fail with status 400 when jobsIds does not exists', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12() {
            var jobIDs, expected;
            return regeneratorRuntime.wrap(function _callee12$(_context12) {
              while (1) {
                switch (_context12.prev = _context12.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 30000;

                    _context12.prev = 1;
                    jobIDs = ['1234'];
                    _context12.next = 5;
                    return (0, _Job.removeJobsAsync)(jobIDs, token.accessToken);

                  case 5:
                    _context12.next = 11;
                    break;

                  case 7:
                    _context12.prev = 7;
                    _context12.t0 = _context12['catch'](1);
                    expected = {
                      statusCode: 400,
                      statusText: 'Bad Request',
                      message: 'Bad Request',
                      errorMessage: [{ key: 'jobIds', messages: ['One or more job(s) not found.'] }]
                    };

                    expect(_context12.t0).toEqual(expected);

                  case 11:
                  case 'end':
                    return _context12.stop();
                }
              }
            }, _callee12, undefined, [[1, 7]]);
          })));

          it('remove job should fail with status 404 when jobsId does not exists', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13() {
            var jobID;
            return regeneratorRuntime.wrap(function _callee13$(_context13) {
              while (1) {
                switch (_context13.prev = _context13.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 30000;

                    _context13.prev = 1;
                    jobID = '1234';
                    _context13.next = 5;
                    return (0, _Job.cancelJobAsync)(jobID, token.accessToken);

                  case 5:
                    _context13.next = 10;
                    break;

                  case 7:
                    _context13.prev = 7;
                    _context13.t0 = _context13['catch'](1);

                    expect(_context13.t0).toHaveProperty('statusCode', 404);

                  case 10:
                  case 'end':
                    return _context13.stop();
                }
              }
            }, _callee13, undefined, [[1, 7]]);
          })));

          describe('should get proof download', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee15() {
            return regeneratorRuntime.wrap(function _callee15$(_context15) {
              while (1) {
                switch (_context15.prev = _context15.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    it('Should get auth error if there is no proper token', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee14() {
                      var response;
                      return regeneratorRuntime.wrap(function _callee14$(_context14) {
                        while (1) {
                          switch (_context14.prev = _context14.next) {
                            case 0:
                              _context14.prev = 0;
                              _context14.next = 3;
                              return (0, _Job.getProofDownload)({
                                jobId: _Config2.default.orderId,
                                locationId: '123',
                                token: '123'
                              });

                            case 3:
                              response = _context14.sent;

                              expect('data' in response).toBeTruthy();
                              _context14.next = 10;
                              break;

                            case 7:
                              _context14.prev = 7;
                              _context14.t0 = _context14['catch'](0);

                              expect(_context14.t0).toHaveProperty('statusCode', 401);

                            case 10:
                            case 'end':
                              return _context14.stop();
                          }
                        }
                      }, _callee14, undefined, [[0, 7]]);
                    })));

                  case 2:
                  case 'end':
                    return _context15.stop();
                }
              }
            }, _callee15, undefined);
          })));

          describe('delete draft job', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee17() {
            return regeneratorRuntime.wrap(function _callee17$(_context17) {
              while (1) {
                switch (_context17.prev = _context17.next) {
                  case 0:
                    jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

                    it('Should get auth error if there is no proper token', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee16() {
                      var response;
                      return regeneratorRuntime.wrap(function _callee16$(_context16) {
                        while (1) {
                          switch (_context16.prev = _context16.next) {
                            case 0:
                              _context16.prev = 0;
                              _context16.next = 3;
                              return (0, _Job.removeDraftJobAsync)(_Config2.default.orderId, '123');

                            case 3:
                              response = _context16.sent;

                              expect('data' in response).toBeTruthy();
                              _context16.next = 10;
                              break;

                            case 7:
                              _context16.prev = 7;
                              _context16.t0 = _context16['catch'](0);

                              expect(_context16.t0).toHaveProperty('statusCode', 401);

                            case 10:
                            case 'end':
                              return _context16.stop();
                          }
                        }
                      }, _callee16, undefined, [[0, 7]]);
                    })));

                  case 2:
                  case 'end':
                    return _context17.stop();
                }
              }
            }, _callee17, undefined);
          })));

        case 28:
        case 'end':
          return _context18.stop();
      }
    }
  }, _callee18, undefined);
})));