'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Logging = undefined;

var _worker = require('worker');

var _worker2 = _interopRequireDefault(_worker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var Logging = exports.Logging = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(errorLimit, interval, token) {
    var worker, errorCounts;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            worker = new _worker2.default('./LoggingWorker.js');
            errorCounts = 0;
            // Handle Message from web worker

            worker.addEventListener('callBack', catchErrorCounts.bind(null, errorCounts));

            // Send Message from web worker
            worker.postMessage('checkConnection', errorLimit, interval, token);

            // Stop Message to web worker;
            worker.close();

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function Logging(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

/**
 * CatchErrorCounts from worker
 * @param {int} errorCounts
 * @param {event} event
 */
function catchErrorCounts(errorCounts, event) {
  errorCounts = event.data;
}