'use strict';

var _Notification = require('../Notification');

var _Auth = require('../../account/Auth');

var _Config = require('./Config');

var _Config2 = _interopRequireDefault(_Config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

describe('Test for retrieving all notifications', function () {
  var token = void 0;
  beforeAll(_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;
            _context.next = 3;
            return (0, _Auth.getTokenAsync)(_Config2.default.email, _Config2.default.password, _Config2.default.clientId, _Config2.default.clientSecret);

          case 3:
            token = _context.sent;

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  })));

  it('should return all users notifications', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var filters, response, notifications;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

            filters = {
              limit: 10
            };
            _context2.prev = 2;
            response = (0, _Notification.getUserNotificationsAsync)(filters, 1, token.accessToken);
            _context2.next = 6;
            return response;

          case 6:
            notifications = _context2.sent;

            expect('data' in notifications).toBeTruthy();
            expect(notifications.data).toMatchSnapshot();
            _context2.next = 14;
            break;

          case 11:
            _context2.prev = 11;
            _context2.t0 = _context2['catch'](2);

            expect(_context2.t0).toHaveProperty('statusCode', 400);

          case 14:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined, [[2, 11]]);
  })));

  it('Update notifications', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

            _context3.prev = 1;
            _context3.next = 4;
            return (0, _Notification.putUserNotification)([], token.accessToken);

          case 4:
            _context3.next = 9;
            break;

          case 6:
            _context3.prev = 6;
            _context3.t0 = _context3['catch'](1);

            expect(_context3.t0).toHaveProperty('statusCode', 400);

          case 9:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined, [[1, 6]]);
  })));

  it('Delete Multiple notifications', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
    var notificationIds, response;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

            notificationIds = [];
            _context4.prev = 2;
            _context4.next = 5;
            return (0, _Notification.deleteUserNotificationAsync)(notificationIds, token.accessToken);

          case 5:
            response = _context4.sent;

            expect(response.data).toBeTruthy();
            _context4.next = 12;
            break;

          case 9:
            _context4.prev = 9;
            _context4.t0 = _context4['catch'](2);

            expect(_context4.t0).toHaveProperty('statusCode', 400);

          case 12:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined, [[2, 9]]);
  })));

  it('should return all counts for notifications', _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            jasmine.DEFAULT_TIMEOUT_INTERVAL = 60000;

            _context5.prev = 1;
            _context5.next = 4;
            return (0, _Notification.getUserNotificationCountAsync)(token.accessToken);

          case 4:
            _context5.next = 9;
            break;

          case 6:
            _context5.prev = 6;
            _context5.t0 = _context5['catch'](1);

            expect(_context5.t0).toHaveProperty('statusCode', 400);

          case 9:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, undefined, [[1, 6]]);
  })));
});