'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createDepotAsync = exports.getDepotsAsync = undefined;

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _Endpoint = require('../Endpoint');

var _Endpoint2 = _interopRequireDefault(_Endpoint);

var _camelize = require('camelize');

var _camelize2 = _interopRequireDefault(_camelize);

var _Util = require('../utility/Util');

var _ChangeCase = require('../utility/ChangeCase');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

/**
 * Returns list of depots
 * @param {object} filterObject # {page, limit}
 * @param {string} token
 * @return {object} Promise resolve/reject
 */

var getDepotsAsync = exports.getDepotsAsync = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(token) {
    var filterObject = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var paramString, depots;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            paramString = (0, _Util.convertObjectIntoURLString)(filterObject);
            _context.prev = 1;
            _context.next = 4;
            return (0, _axios2.default)({
              method: 'GET',
              url: '' + _Endpoint2.default.API_V3.DEPOTS.replace('{0}', paramString.replace('&', '?')),
              headers: { Authorization: 'Bearer ' + token }
            });

          case 4:
            depots = _context.sent;
            return _context.abrupt('return', (0, _camelize2.default)(depots.data));

          case 8:
            _context.prev = 8;
            _context.t0 = _context['catch'](1);
            return _context.abrupt('return', (0, _Util.apiResponseErrorHandler)(_context.t0));

          case 11:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[1, 8]]);
  }));

  return function getDepotsAsync(_x2) {
    return _ref.apply(this, arguments);
  };
}();

/**
 * create Depot
 * @param {string} token
 * @param {object} data depot data object
 * @return {object} Promise resolve/reject
 */
var createDepotAsync = exports.createDepotAsync = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(token, data) {
    var depot;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            _context2.next = 3;
            return (0, _axios2.default)({
              method: 'POST',
              url: _Endpoint2.default.API_V3.DEPOTS,
              headers: { Authorization: 'Bearer ' + token },
              data: (0, _ChangeCase.camelToSnake)(data)
            });

          case 3:
            depot = _context2.sent;
            return _context2.abrupt('return', (0, _camelize2.default)(depot.data));

          case 7:
            _context2.prev = 7;
            _context2.t0 = _context2['catch'](0);
            return _context2.abrupt('return', (0, _Util.apiResponseErrorHandler)(_context2.t0));

          case 10:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined, [[0, 7]]);
  }));

  return function createDepotAsync(_x3, _x4) {
    return _ref2.apply(this, arguments);
  };
}();