'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getCountriesAsync = undefined;

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _http = require('axios/lib/adapters/http');

var _http2 = _interopRequireDefault(_http);

var _Endpoint = require('../Endpoint');

var _Endpoint2 = _interopRequireDefault(_Endpoint);

var _camelize = require('camelize');

var _camelize2 = _interopRequireDefault(_camelize);

var _Util = require('../utility/Util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * @fileoverview This file contains all Country related functions that are triggered by a (public) User
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */

/**
 * Retrieve all countries
 * @param {object} filterObject # {sort}
 * Available sorts:
 * - country_name
 * - country_code
 * - dialing_code
 * Available orders:
 * - asc
 * - desc
 * Example: dialing_code,desc
 * @return {object} Promise resolve/reject
 */

var getCountriesAsync = exports.getCountriesAsync = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var filterObject = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var paramString, response;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            paramString = (0, _Util.convertObjectIntoURLString)(filterObject);
            _context.prev = 1;
            _context.next = 4;
            return _axios2.default.get(_Endpoint2.default.API_V3.COUNTRIES.replace('{0}', paramString.replace('&', '?')), { adapter: _http2.default });

          case 4:
            response = _context.sent;
            return _context.abrupt('return', (0, _camelize2.default)(response.data.data));

          case 8:
            _context.prev = 8;
            _context.t0 = _context['catch'](1);
            return _context.abrupt('return', (0, _Util.apiResponseErrorHandler)(_context.t0));

          case 11:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[1, 8]]);
  }));

  return function getCountriesAsync() {
    return _ref.apply(this, arguments);
  };
}();